<?php
//---------------------------------------------------------
// creates a resource inforamtion for an avp
//---------------------------------------------------------

// require_once( PHPLIB_PATH."/helpers.php" );
// require_once( PHPLIB_PATH."/sessionMBox.php" );
// require_once( PHPLIB_PATH."/npstream.php" );
// require_once( PHPLIB_PATH."/np_awf.php" );



/******************************************************************
 * AvpResrc
 * 
 ******************************************************************/
class AvpResrc
{
  //-------------------------------------------------------
  //  MEMBER VARIABLES
  //-------------------------------------------------------
  private $base;
  private $ins;
  private $outs;
  private $tiles;
  private $xml;
  private $jsonData;
  private $exp;
    //-------------------------------------------------------
  //  CONSTRUCT
  //-------------------------------------------------------
  function __construct( )
  {
    //init var with null. after create* it will be still null if no element are found.
    $this->base   = null;
    $this->ins    = null;
    $this->outs   = null;
    $this->tiles  = null;
    $this->xml    = null;
    $this->exp    = null;
    
  }
  //-------------------------------------------------------
  //  ABSTRACTS
  //-------------------------------------------------------
  
  //-------------------------------------------------------
  //  METHODS
  //-------------------------------------------------------
  
  /**--------------------------------------------------------
   * createBase()
   * 
   * createBase handles all standart values of the device
   * 
   */
  private function createBase()
  {
    $this->base = Array();
    //showdatetime
    array_push( $this->base, $this->createSimpleModule( "none", "showTime", "true" ) );
    array_push( $this->base, $this->createSimpleModule( "none", "volumeRing", "60" ) );
    array_push( $this->base, $this->createSimpleModule( "none", "volumeVoice", "60" ) );
    array_push( $this->base, $this->createSimpleModule( "none", "houseControl", "none", "url" ) );
    array_push( $this->base, $this->createSimpleModule( "function", null, "grabpic", "sp", "grabpic" ) );
    //array_push( $this->base, $this->createSimpleModule( "none", "announcementvol", "60" ) );
    //array_push( $this->base, $this->createSimpleModule( "function", "redir", "true", "sp" ) );
    //array_push( $this->base, $this->createSimpleModule( "function", "dnd", "true", "sp" ) );
    //array_push( $this->base, $this->createSimpleModule( "function", "presence", "presence", "sp" ) );
    
    
  }
  /**-------------------------------------------------------
   * createIns()
   * 
   * createIns handles all possible input values
   */
  private function createIns()
  {
    $module = null;$uid = null;$abbr = null;
    $this->ins = Array();
    $inputs = $this->xml->xpath("/siedle/resrc/io/int/in");
    if ( sizeof( $inputs ) > 0 )  {
      foreach ($inputs as $key => $input) {
        //echo strval( $input->label ) . "<br>";
        if( strval( $input->label ) == "RJ45-3_6" )  {
          $module = "IO";
          $uid    = "ahtf_e1";
          $abbr   = "E1";
          array_push( $this->ins, $this->createIoModule( $module, 0, "in", $uid, $abbr, "none", intval( $input->id ) ) );
        }
        else if ( strval( $input->label ) == "TA1" )  {
          $module = "KBD";
          $uid    = "key1";
          $abbr   = "K1";
          array_push( $this->ins, $this->createKBDModule($module, 0, $uid, $abbr, "none", intval( $input->id ) ) );
        }
      }
    }
  }
  
  /**-------------------------------------------------------
   * createOuts()
   * 
   * createIns handles all possible output values
   */
  private function createOuts()
  {
    $this->outs = Array();
    $outs = $this->xml->xpath("/siedle/resrc/io/int/out");
    if ( sizeof( $outs ) > 0 )  {
      foreach ($outs as $key => $out) {
        if( strval( $out->label ) == "LD1_spare" )  {
          $uid  = "ld1";
          $abbr = "L1";
          array_push( $this->outs, $this->createIoModule( "LED", 0, "out", $uid, $abbr, "none", intval( $out->id ) ) );
          continue;
        }
        else if ( strval( $out->label ) == "RJ45-4_5" )  {
          $uid  = "ahtf_a1";
          $abbr = "A1";
          $this->CreateIoModule( "IO", 0, "out", $uid, $abbr, "none", intval( $out->id ) );
          array_push( $this->outs, $this->createIoModule( "IO", 0, "out", $uid, $abbr, "none", intval( $out->id ) ) );
        }
      }
    }
  }

  /**-------------------------------------------------------
   * createIns()
   * 
   * createIns handles all possible Tiles like keys from 
   * apartment devices
   */
  private function createTiles()
  {
    $this->tiles = Array();
    for ($i=1; $i < 45 ; $i++) {
      $newTile = $this->createTileModule("TILE", 0, "tile" . $i, "T".$i, "none", $i);
      array_push( $this->tiles, $newTile);
    }
  }

  /**-------------------------------------------------------
   * CreateAzio( $exp )
   */
  private function CreateExpAzio( $exp )
  {
    if( !$exp )  {
      return false;
    }
    
    $inputs  = $exp->xpath( ".//in" );
    $outputs = $exp->xpath( ".//out" );
    foreach( $inputs as $key => $input )  {
      if( strval( $input->label ) == "RJ45-1_2" ) {
        $uid  = "ahtf_e2";
        $abbr = "E2";
        $temp = $this->CreateIoModule( "AZIO", 0, "in", $uid, $abbr, "none", intval( $input->id ) );
        array_push( $this->exp, $temp);
      }
    };
    foreach( $outputs as $key => $output )  {
      if( strval( $output->label ) == "RJ45-7_8" ) {
        $uid  = "ahtf_a2";
        $abbr = "A2";
        $temp = $this->CreateIoModule( "AZIO", 0, "out", $uid, $abbr, "none", intval( $output->id ) );
        array_push( $this->exp, $temp);
      }
    };
  }

  /**-------------------------------------------------------
   * createExps()
   * 
   * createIns handles all possible output values
   */
  private function CreateExps()
  {
    $moduleName  = "";
    $countAtlce  = 0;
    $this->exp   = Array();
    $exps        = $this->xml->xpath("/siedle/resrc/io/exp");
    if ( sizeof( $exps ) > 0 )  {
      foreach ($exps as $expKey => $exp) {
        $moduleName = strval( $exp->name );
        $this->AddModuleCount( $moduleName );
        switch( $moduleName )  {
          case "AZIO":
          $this->createExpAzio( $exp );
          break;
        }
      }
    } 
  }
  
  /**-------------------------------------------------------
   * xmlToDevConfig()
   * 
   * xmlToDevConfig analyses a xml String for key avp words
   * like in, out ...
   */
  public function xmlToDevConfig( $xmlString )
  {
    $this->xml = $xmlString;
    $this->xml = simplexml_load_string( $this->xml );
    $resultArray = Array();
    //init data
    $this->createBase();
    $this->createIns();
    $this->createOuts();
    $this->createExps();
    $this->createTiles();
    
    //$resultArray = $resultArray + $this->base;
    $resultArray = array_merge( $resultArray, $this->base );
    $resultArray = array_merge( $resultArray, $this->ins );
    $resultArray = array_merge( $resultArray, $this->outs );
    $resultArray = array_merge( $resultArray, $this->tiles );
    $resultArray = array_merge( $resultArray, $this->exp );

    //output
    
    //debug
    // echo "<pre>";
    // echo( json_encode( $resultArray, JSON_PRETTY_PRINT ) );
    // echo "</pre>";
    return $resultArray;
    
  }

   /**-------------------------------------------------------
   * xmlToDevJson()
   * 
   * xmlToDevConfig analyses a xml String for key avp words
   * like in, out ...
   */
  public function XmlToJson( $xmlString )
  {
    $this->xml = $xmlString;
    $this->xml = simplexml_load_string( $this->xml );
    $resultArray = Array();
    $this->jsonData = Array();
    
    //init data
    $this->CreateBase();
    $this->CreateIns();
    $this->createOuts();
    $this->CreateExps();
    $this->createTiles();
  
    $this->getAllUID();
    $resultArray = Array(
      "uid"      => $this->jsonData,
      "function" => ['redir','dnd','presence','grabpic','volumeVoice','volumeRing','mountType','showTime']
    );
    return  $resultArray;
  }

  public function getAllUID()
  {
    /*
    private $base;
  private $ins;
  private $outs;
  private $tiles;
    */
    if( isset( $this->base ) )  {
      foreach( $this->base as $key=>$value ) {
        if( isset( $value['uid'] ) ) {
          array_push( $this->jsonData, $value['uid'] );
        }
        else {
          array_push( $this->jsonData, $value['template'] );
        }
      }
    }
    if( isset( $this->ins ) )  {
      foreach( $this->ins as $key=>$value )  {
        array_push( $this->jsonData, $value['uid'] );
      }
    }
    if( isset( $this->outs ) )  {
      foreach( $this->outs as $key=>$value )  {
        array_push( $this->jsonData, $value['uid'] );
      }
    }
    if( isset( $this->tiles ) )  {
      foreach( $this->tiles as $key=>$value )  {
        array_push( $this->jsonData, $value['uid'] );
      }
    }
    if( isset( $this->exp ) )  {
      foreach( $this->exp as $key=>$value )  {
        array_push( $this->jsonData, $value['uid'] );
      }
    }
  }

  //-------------------------------------------------------
  //  Helpers
  //-------------------------------------------------------
  /**------------------------------------------------------
   * createModule()
   * 
   * 
   */
   private function createSimpleModule( $module, $template, $value, $valueKey = null )
   {
    $retArray = null;
    if( !isset( $valueKey ) )  {
       $retArray = Array(
        "module"    => $module,
        "template"  => $template,
        "$template" => $value,
       );
    }
    else  {
      $retArray = Array(
        "module"    => $module,
        "template"  => $template,
        "$valueKey" => $value,
       );
    };
    return $retArray;
   }
   /**------------------------------------------------------
   * createTileModule( $module, $modId, $uid, $abbr, $template, $sysId )
   * 
   * 
   */
   private function createTileModule( $module, $modId, $uid, $abbr, $template, $sysId )
   {
    $retArray = null;
    $retArray = Array(
      "module"    => $module,
      "modid"     => $modId,
      "uid"       => $uid,
      "abbr"      => $abbr,
      "trigger"   => "single",
      "template"  => $template,
      "label"     => "{\$aui_lang_tile}",
      "icon"      => "none",
      "actionid"  => $sysId + 4,
      "stateid"   => $sysId + 4,
      "in"        => Array(
        "sysid" => $sysId
      )
    );
    
    return $retArray;
   }
   /**------------------------------------------------------------------------
    * createKBDModule( $module, $modId, $uid, $abbr, $template, $sysId )
    */
   private function createKBDModule( $module, $modId, $uid, $abbr, $template, $sysId )
   {
    $retArray = null;
    $retArray = Array(
      "module"    => $module,
      "modid"     => $modId,
      "uid"       => $uid,
      "abbr"      => $abbr,
      "trigger"   => "single",
      "opener"    => true,
      "template"  => $template,
      "in"        => Array(
        "sysid" => $sysId
      )
    );
    
    return $retArray;
   }
   /**------------------------------------------------------
   * createIoModule( $module, $modId, $mode, $uid, $abbr, $template, $sysId )
   * 
   * 
   */
   private function createIoModule( $module, $modId, $mode, $uid, $abbr, $template, $sysId )
   {
    $retArray = null;
    $retArray = Array(
      "module"    => $module,
      "modid"     => $modId,
      "uid"       => $uid,
      "abbr"      => $abbr,
      "template"  => $template,
      $mode       => Array(
        "sysid"   => $sysId
      )
    );
    if( $mode == "in" )  {
      $retArray['trigger'] = "sensor";
    }
    return $retArray;
   }

   /**-----------------------------------------------------
    * AddModule( $moduleName )
    */
    private function AddModuleCount( $moduleName )
    {
      if( isset( $this->moduls[ $moduleName ] ) ) {
       $this->moduls[ $moduleName ]++;
      }
      else  {
        $this->moduls[ $moduleName ] = 1;
      }
    }
 
    /**-----------------------------------------------------
     * GetModuleCount( $moduleName )
     */

     private function GetModuleCount( $moduleName )
     {
       if( isset( $this->moduls[ $moduleName ] ) ) {
        return $this->moduls[ $moduleName ];
       }
       else  {
         $this->AddModuleCount( $moduleName );
         return 1;
       }
     }
    }

?>