<?php
//---------------------------------------------------------
// merge device informations with admin and user settings
//---------------------------------------------------------
/******************************************************************
 * ResConverter
 * 
 ******************************************************************/
class ResrcConverter {
  
  private $postData;
  private $getData;
  private $resrc;
  private $ioCount;
  private $moduleId;
  private $avp;
  private $door;
  private $apartment;
  private $rawXmlText;
  private $countModules = Array(
    "ATLCE" => 0,
    "BTM"   => 0
  );
  private $resultResrcJson = Array();
  private $defaultConf = Array(
      'module'    => '',
      'modid'     => '',
      'type'      => '',
      'id'        => '',
      'trigger'   =>'noaction',
      'template'  => 'none'
    );
  private $defaultInOut = Array(
    'sysid' => 0, //id aus resrc
    'sysname' => '' //label
  );
  public $cam = false;
  
  //define const I/O names(letters)
  const INPUT_ABBR     = "E";
  const OUTPUT_ABBR    = "A";
  const LIGHTKEY_ABBR  = "L";
  const KEYABBR        = "K";
  
  /**----------------------------------------------------------------
   * constructor
   * 
   * 
   */
  function __construct( $post, $get ) {
    $this->apartment  = new ApartmentResrc();
    $this->avp        = new AvpResrc();
    $this->door       = new DoorResrc();
    $this->rawXmlText = $post;
    $this->ioCount    = 0;
    $this->ioCount    = 0;
    //receive device informations from GET-Methode
    $action           = $get['act'];
    $macAddr          = $get['mac'];
    $devtype          = null; 
    $hwtype           = $get['hwtype'];
    
    $this->resrc = simplexml_load_string( $post );
    
    preg_match( "/[^\s\d_]*/", $_GET['devtype'], $devtype );
    
    if( empty($post) )  {
      //echo "Error \$_POST is empty";
      //echo "<hr>";
      //print_r( $post );
      return FALSE;
    }
    switch ( $devtype[0] ) {
      case 'ATLC':
        //$this->createATLCIOs( $this->resrc );
        //$this->resultResrcJson = $this->door->xmlToDevConfig( $this->rawXmlText );
        $this->resultResrcJson = $this->door->xmlToJson( $this->rawXmlText );
        break;
     case 'AHFV':
     case 'AHF':
     case 'AHTV':
     case 'AHT':
     case 'ALFP':
        $this->resultResrcJson = $this->apartment->xmlToJson( $this->rawXmlText );
        break;
     case 'AVP':
       $this->resultResrcJson = $this->avp->xmlToJson( $this->rawXmlText );
      default:
        
        break;
    }
    $macAddr = strtolower( preg_replace( "/:/", "-", $get['mac'] ) );
    //$this->debugXmlString( json_encode( $this->resultResrcJson, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES|JSON_UNESCAPED_UNICODE ) );
    $this->resultResrcJson = Array(
      "devconfig" => $this->resultResrcJson
    );

  }
  /**--------------------------------------------------
   * return array of converted data
   */
  function getResult()
  {
    return $this->resultResrcJson['devconfig'];
  }

  /*--------------------------------------------------
   * hasCamera( $entity )
   * @param list array deviceConfig of mainObject/entity
   * @result array Array( "cam" => true, "key" => 2)
   */
  public function hasCamera()
  {
    $hasCamera = false;

    if ( isset( $this->door ) )  {
      $hasCamera = $this->door->GetHasCameraModule();
    }

    return $hasCamera;
  }
}

/*---------------------------------------------------------------
 * 
 *                      HELPERS
 * 
 * --------------------------------------------------------------
/*--------------------------------------------------
 * getEntity
 */
function getEntity( $entid )
{
  global $np;
  $cfs = new ConfigStore( $np );
  $entity = $cfs->EntityRead( $entid );
  return $entity;
}
 
/*--------------------------------------------------
 * createCamStatPt
 * @param entity array whole entity from configstore
 */
function createCamStatPt( &$entity, $serverName )
{
  $entity['sp']['camera'] = Array(
    "default"   => false,
    "label"     => "{\$aui_widget_camera}",
    "address"   => $serverName . "/" . $entity['entid'] . "/camera",
    "type"      => "CAMERA",
    "name"      => "camera",
    "template"  => "camera"
  );
}

/*--------------------------------------------------
 * deleteCamStatPt( &$entity )
 * @param entity array whole entity from configstore
 */
function deleteCamStatPt( &$entity )
{
  unset ( $entity['sp']['camera'] );
}

/*--------------------------------------------------
 * deletePermission( &$entity )
 * @param entity array whole entity from configstore
 */
function deletePermission( &$entity, $filter )
{
  foreach ($entity['permission'] as $key => $value) {
    if( $value['f'] == $filter )  {
      unset( $entity['permission'][$key] );
      break;
    }
  }
}



/*---------------------------------------------------
 * mergeDevConfig
 * defconf and resrc are arrays
 */
// TODO cleanup merge function
function mergeDevConfig( $devconf, $resrc)
{
  $newThings = Array();
  $newDefconf = $resrc;
  
  
  // file_put_contents("devonfig".time(), json_encode($devconf, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES|JSON_UNESCAPED_UNICODE));
  // file_put_contents("resrc".time(), json_encode($resrc, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES|JSON_UNESCAPED_UNICODE));
  if( sizeof( $devconf) <= 0 )  {
    $defconf = $resrc;
  }
  else  {
    foreach ( $devconf as $devkey => $devconfig ) {
      $found = false;
      foreach ( $resrc as $reskey => $resconfig ) {
        //check if a config already exists in devconfig
        // save actually buscontroller#
        if( isset( $resconfig['buscontroller'] ) )  {
          $devconf[$devkey]['buscontroller'] = $resconfig['buscontroller'];
          } 
      
        if( isset( $resconfig['uid'], $devconfig['uid'] )      && $devconfig['uid'] == $resconfig['uid'] &&
            isset($resconfig['module'], $devconfig['module'] ) && $devconfig['module'] == $resconfig['module'] )  {
          if( isset($resconfig['trigger'], $devconfig['trigger'] ) && $devconfig['trigger'] == $resconfig['trigger'] )  {
            
            $found = true;
            //echo"found key: " . $devconfig['module']. " " . $devconfig['uid']. " " . $devconfig['abbr'] . " with " . $devconfig['trigger'] ."<br>\n";
            $newDefconf[$reskey] = $devconf[$devkey];
            // file_put_contents("res_convert.debug", "update component(".__LINE__."): '" . " devconfig " . $devconfig['uid'] . "' - '" . $devconfig['template'] . " || resconfig " . $resconfig['uid'] . "' - '" . $resconfig['template'] . "'\n", FILE_APPEND);
            break;
          }
          else if( !isset( $devconfig['trigger'] ) )  {
            
            $found = true;
            $newDefconf[$reskey] = $devconf[$devkey];
            // file_put_contents("res_convert.debug", "update component(".__LINE__."): '" . " devconfig " . $devconfig['uid'] . "' - '" . $devconfig['template'] . " || resconfig " . $resconfig['uid'] . "' - '" . $resconfig['template'] . "'\n", FILE_APPEND);
            break;
          }
          
          
        }
        else if( isset($resconfig['template']) && isset($resconfig[$resconfig['template']]) && isset($devconfig[$devconfig ['template']]) &&
                $devconfig['template'] == $resconfig['template'] )  {
          $found = true;
          // file_put_contents("res_convert.debug", "update component(".__LINE__."): '" . " devconfig " . $devconfig['uid'] . "' - '" . $devconfig['template'] . " || resconfig " . $resconfig['uid'] . "' - '" . $resconfig['template'] . "'\n", FILE_APPEND);
          $newDefconf[$reskey] = $devconf[$devkey];
          break;
        }
        else if( isset($resconfig['template']) && isset($devconfig['template']) && $devconfig['template'] == $resconfig['template'] && isset($devconfig['sp'], $resconfig['sp']) )  {
          $found = true;
          // file_put_contents("res_convert.debug", "update component(".__LINE__."): '" . " devconfig " . $devconfig['uid'] . "' - '" . $devconfig['template'] . " || resconfig " . $resconfig['uid'] . "' - '" . $resconfig['template'] . "'\n", FILE_APPEND);
          $newDefconf[$reskey] = $devconf[$devkey];
          break;
        }
        // save actually buscontroller#
        if( isset( $resconfig['buscontroller'] ) )  {
          $devconf[$devkey]['buscontroller'] = $resconfig['buscontroller'];
          } 
      }
      if( !$found && isset($devconfig['template']) )  {
        //echo "<br>" . $devconfig['template'] ."<br>";
        // file_put_contents("res_convert.debug", "add new component(".__LINE__."): '" . " devconfig " . $devconfig['uid'] . "' - '" . $devconfig['template'] . "'\n", FILE_APPEND);
        //$resrc[] = $devconf[$devkey];
        if( $devconfig['module'] != "BTM" && $devconfig['module'] != "BRMA" && $devconfig['module'] != "KBD" && $devconfig['module'] != "TA" &&  $devconfig['module'] != "AZIO" &&
            $devconfig['module'] != "TILE" && $devconfig['module'] != "ATLM" /*&& !( $devconfig['module'] == "function" && $devconfig['template'] == "camera" ) /*&& !( $devconfig['module'] == "function" && $devconfig['template'] == "grabpic" )*/  )  {
          array_push($newThings,$devconfig);
        }
        
      }
    }
  }
  $newDefconf = array_merge( $newDefconf, $newThings );

  // file_put_contents("merged".time(), json_encode($newThings, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES|JSON_UNESCAPED_UNICODE));
  $newArray = array_values( $newDefconf );
  return $newArray;
}

?>