<?php
/******************************************************************************
 *    ENTITY CREATE - TEMPLATING
 *  -------------------------------------------------------------------------
 *
 *  creates a new entity given a template and some parameters
 *
 *****************************************************************************/

class EntityTemplates
{
  /*-------------------------------------------------------
   *  member variables
   */
  protected $params   = Array( 'this' => null, 'parent' => null, 'system' => null );
  protected $mustache = null;
  protected $template = null;
  protected $lang     = 'de';

  /*-------------------------------------------------------
   *  constructor
   */
  function __construct( $entclass )
  {
    if( file_exists( ENTTPL_PATH . $entclass . '.json' ) )  {
      $this->template = file_get_contents( ENTTPL_PATH . $entclass . '.json' );
      $this->template = json_decode( $this->template, true );
      if( $this->ResourceNeeded( "random_password") )  {
        $bytes = openssl_random_pseudo_bytes( 3 );
        $this->params['this']['password'] = bin2hex( $bytes );
      }
      else  {
        $this->params['this']['password'] = "0000";
      }
    }
  }

  /*-------------------------------------------------------
   *  writer
   */
  function ResourceNeeded( $key )
  {
    if( $this->template
     && key_exists( 'meta', $this->template )
     && key_exists( 'resources', $this->template['meta'] )
      )  {
      if( key_exists( $key, $this->template['meta']['resources'] ) )  {
        return true;
      }
    }
    return false;
  }

  /*-------------------------------------------------------
   *  writer
   */
  function Entype( )
  {
    if( $this->template )  {
      $cls   = $this->template['data']['class'];
      $entid = $this->template['data']['entid'];
      $entid = substr( $entid, 0, strlen($cls) );
      //if( $cls != $entid )  {
      //  return $this->template['data']['entype'];
      //}
      //else  {
        return $this->template['data']['class'];
      //}
    }
    return null;
  }

  /*-------------------------------------------------------
   *  writer
   */
  function Create( $params, $lang )
  {
    // load ok?
    if( $this->template == null )   return false;

    // set language params
    if( key_exists( $lang, $this->template['meta']['lang'] ) )  {
      $params = array_merge( $params, $this->template['meta']['lang'][$lang] );
    }

    // render params into the template file
    $this->mustache = @new Mustache_Engine;
    $result = json_encode( $this->template['data'], JSON_PRETTY_PRINT|JSON_UNESCAPED_UNICODE );
    $result = @$this->mustache->render( $result, $params );

    return json_decode( $result, true );
  }

  /*-------------------------------------------------------
   *  get the created password
   */
  function GetPasswords( )
  {
    return $this->params['this']['password'];
  }
};

?>