<?php
//-----------------------------------------------------------------------------
//
//  AccessLib
//  (c) 2019  CYTEL Technology AG
//
//  Editor: Tobias Stumpf
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  CLASS
//-----------------------------------------------------------------------------
class GenericProxy
{
  //-----------------------------------------------------------------
  //  variables
  //-----------------------------------------------------------------

  private $envelope = Array();
  private $action;


  //error messages
  const ERROR_COMMAND_IS_MISSING    = "404 - Envelope format error: Missing 'meta.cmd'";
  const ERROR_GUID_IS_MISSING       = "404 - Envelope format error: Missing 'meta.guid'";
  const ERROR_SESSION_IS_MISSING    = "404 - Envelope format error: Missing 'meta.session'";

  //-----------------------------------------------------------------
  //  methods
  //-----------------------------------------------------------------

  /**
   * @param $envelope array array which represents an envelope
   * @return array response envelope from server or error envelope from php
   */
  public function WorkEnvelope( $envelope )
  {
    $this->envelope = $envelope;

    //if ( !$this->ProcessRequestEnvelope() )  {
    //  return $this->envelope;
    //};



    // send the command to the server
    $responseEnvelope = $this->SendEnvelope();
    return $responseEnvelope;
  }

  /**
   * check if necessary information are available
   * maybe obsolete because the server check these values anyway.<br><br>
   * **CAUTION**:<br>
   * If these checks will be removed consider that the server doesn't send a correct envelope.
   * In these cases the server response with plain text.
   *
   * @return bool
   */
  private function ProcessRequestEnvelope(  )
  {

    // check envelope of missing parameters
    if( !isset( $this->envelope['meta']['command'] ) || empty( $this->envelope['meta']['command'] ) )  {
      $this->envelope['meta']['status'] = GenericProxy::ERROR_COMMAND_IS_MISSING;
      return false;
    }

    if( !isset( $this->envelope['meta']['guid'] ) || empty( $this->envelope['meta']['guid'] ) )  {
      $this->envelope['meta']['status'] = GenericProxy::ERROR_GUID_IS_MISSING;
      return false;
    }

    if( !isset( $this->envelope['meta']['session'] ) || empty( $this->envelope['meta']['session'] ) )  {
      $this->envelope['meta']['status'] = GenericProxy::ERROR_SESSION_IS_MISSING;
      return false;
    }
  }

  /**
   *
   * @return bool
   */
  private function SendEnvelope()  {
    $response = NamedPipe::Send( json_encode( $this->envelope ) );
    return json_decode( $response, true );
  }
}
?>