<?php
/***********************************************************
 * SessionProxy
 *
 *
 */

class SessionProxy
{
  private $m_commandPrefix = "SESSION.";
  private $m_sessionId;

  public function __construct( $sessionId )
  {
    $this->m_sessionId = $sessionId;
  }


  /*********************************************************
   * Authorize( $sessionId, $account, $password )
   */
  public function Authorize( $sessionId, $account, $password )
  {
    $data = Array(
      "sessionId" => $sessionId,
      "account"   => $account,
      "password"  => $password
    );
    LOG::debug( __CLASS__, "(%s) password from admin is: %s ", __LINE__, ($password)?$password:"no passwort" );
    $authorizeEnvelope = new Envelope( getGUID(), $this->m_commandPrefix ."AUTHORIZE", $sessionId, $data );
    $response = NamedPipe::Send( $authorizeEnvelope->Get( true ) );
    return json_decode( $response, true );
  }


  /*********************************************************
   * Create( $sessionId, $createdTime, $ipAddr, $hasMailbox = true, $maxInactivitySpan = 900 )
   */
  public function Create( $sessionId, $createdTime, $ipAddr, $browser, $hasMailbox = true, $maxInactivitySpan = 900, $nonce = "" ) //900sek
  {
    $data = Array(
      "sessionId"         => $sessionId,
      "hasMailbox"        => $hasMailbox,
      "maxInactivitySpan" => $maxInactivitySpan,
      "browser"           => $browser,
      "createdTime"       => $createdTime,
      "ipAddr"            => $ipAddr,
      "nonce"             => $nonce
    );
    $authorizeEnvelope = new Envelope( getGUID(), $this->m_commandPrefix ."CREATE", $sessionId, $data );
    $response = NamedPipe::Send( $authorizeEnvelope->Get( true ) );
    return json_decode( $response, true );
  }


  /*********************************************************
   * Delete( $sessionId )
   */
  public function Delete( $sessionId )
  {
    $data = Array(
      "sessionId" => $sessionId
    );
    $authorizeEnvelope = new Envelope( getGUID(), $this->m_commandPrefix ."DELETE", $sessionId, $data );
    $response = NamedPipe::Send( $authorizeEnvelope->Get( true ) );
    return json_decode( $response, true );
  }


  /*********************************************************
   * ResetExpiry( $sessionId )
   */
  public function ResetExpiry( $sessionId )
  {
    $data = Array(
      "sessionId" => $sessionId
    );
    $authorizeEnvelope = new Envelope( getGUID(), $this->m_commandPrefix ."RESET_EXPIRY", $sessionId, $data );
    $response = NamedPipe::Send( $authorizeEnvelope->Get( true ) );
    return json_decode( $response, true );
  }


  /*********************************************************
   * Unautorize( $sessionId )
   */
  public function Unautorize( $sessionId )
  {
    $data = Array(
      "sessionId" => $sessionId
    );
    $authorizeEnvelope = new Envelope( getGUID(), $this->m_commandPrefix ."UNAUTHORIZE", $sessionId, $data);
    $response = NamedPipe::Send( $authorizeEnvelope->Get( true ) );
    return json_decode( $response, true );
  }

  /*********************************************************
   * Get( $sessionId )
   */
  public function Get( $sessionId )
  {
    $data = Array(
      "sessionId" => $sessionId
    );
    $authorizeEnvelope = new Envelope( getGUID(), $this->m_commandPrefix ."GET", $sessionId, $data );
    $response = NamedPipe::Send( $authorizeEnvelope->Get( true ) );
    return json_decode( $response, true );
  }

  /*********************************************************
   * Set( $sessionId )
   *
   */

   public function SetSession( $sessionId )  {
    $this->m_sessionId = $sessionId;
  }
}

?>
