<?php
/*=============================================================================
 *
 *  SETUP
 *
 *  - Script that is called from setup before server is started.
 *  - should be used to perform version update
 *
 ============================================================================*/

//-----------------------------------------------------------------------------
// get the update-script
//
require_once( "helper/localStore.php" );
require_once( "main.php" );
require_once( "php_shared/lib/helpers.php" );


//-----------------------------------------------------------------------------
// access config => defines
//
if( !file_exists( "/etc/access6/access.ini" ) )  {
  exit( "Error: access.ini not found" );
}
else  {
  $ACCESS_INI = parse_ini_file( "/etc/access6/access.ini" );
}
define( "ACCESS_VERSION", $ACCESS_INI['version'] );
define( "ACCESS_BUILD",   $ACCESS_INI['build'] );
define( "DATA_PATH",      $ACCESS_INI['data'] . "data/" );
define( "LOG_PATH",       $ACCESS_INI['data'] . "log/" );
define( "DEVCONF_PATH",   $ACCESS_INI['data'] . "data/devconfig/" );
define( "TFTPD_PATH",     $ACCESS_INI['root'] . "config/tftp-data/" );
define( "TABLES_PATH",    $ACCESS_INI['root'] . "config/tables/" );

if( $argc > 1 && ( $argv[ 1 ] == "-f" || $argv[ 1 ] == "--force" ) ) {
  echo "Force full update due to command line.\r\n";
  define( "FORCE", true );
}
else if( ACCESS_BUILD == 7024 ) {
  echo "Force full update due to Build 7024.\r\n";
  define( "FORCE", true );
}
else {
  define( "FORCE", false );
}

// check for version 6.1, force update 6.1.1 -> 7.0.0
if( strpos( ACCESS_VERSION, "6.1" ) >= 0  ) {
  echo "Force all updates from 6.1\r\n";
  define( "FORCE_6_1", true );
}


//-----------------------------------------------------------------------------
// create local store
//
echo "Start loading config...\r\n";
$localStore = new LocalStore( );


//-----------------------------------------------------------------------------
// run
//
Main();



?>
