<?php

function UpdateTables()
{
  printf( "Start Update Tables\r\n" );
  $statisticUpdatedTables = 0;

  // create a list of tables from tables directory
  $tableTemplateNames = glob( TABLES_PATH . "*.json" );
  $tableNames = Array();
  $tableTemplate = Array();

  // split the table name from path and create search mask
  foreach( $tableTemplateNames as $filePath ) {
    $filename = pathinfo( $filePath )["filename"];
    $tableNames[] = "." . $filename . ".";
    $fileContent = file_get_contents( $filePath );
    $fileContent = json_decode( $fileContent, true );
    $tableTemplate[] = $fileContent;
  }

  // get a list of existing tables in userdata
  $tableList = glob( DATA_PATH . "userdata/*.json" );

  // open each table and replace the meta section
  foreach( $tableList as $tableFileName ) {
    
    // get the table template for current table file
    $tableIndex = -1;
    for( $i = 0; $i < count( $tableNames ); $i++ ) {
      if( strpos( $tableFileName, $tableNames[ $i ] ) ) {
        $tableIndex = $i;
        break;
      }
    }

    // if a table template found...
    if( $tableIndex >= 0 ) {

      // ...and a meta part exists
      if( is_array( $tableTemplate[ $tableIndex ] )
       && array_key_exists( "meta", $tableTemplate[ $tableIndex ] )
       && array_key_exists( "fields", $tableTemplate[ $tableIndex ]["meta"] )
        ) {

        // .. load table.
        $tableFile = file_get_contents( $tableFileName );
        $tableFile = json_decode( $tableFile, true );
        
        // if table is an array..
        if( is_array( $tableFile )
         && array_key_exists( "meta", $tableFile )
         && array_key_exists( "fields", $tableFile["meta"] )
          ) {
          // and the meta part of the table has changed..
          if( IsArrayDifferent( $tableFile["meta"]["fields"], $tableTemplate[ $tableIndex ]["meta"]["fields"] ) ) {

            // ..update.
            $tableFile["meta"]["fields"] = $tableTemplate[ $tableIndex ]["meta"]["fields"];
            $saveContent = json_encode( $tableFile, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE );
            file_put_contents( $tableFileName, $saveContent );
            printf( "  Update table meta: '$tableFileName'\r\n" );
            $statisticUpdatedTables++;
          }
        }
      }

    }// template found

  }// foreach table

  printf( "Update Tables: $statisticUpdatedTables updated.\r\n" );

}

function IsArrayDifferent( &$array1, &$array2 )  
{
  $a1 = json_encode( $array1 );
  $a2 = json_encode( $array2 );
  return $a1 != $a2;
}

?>
