<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for G.46 (> 4060)
 *
 *  1. Add sp 'timeline2' to entity timeline
 *  2. Reconfigure all <signal> outputs to statepoint signal
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update4060()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  if( FORCE || $localStore->GetBuild( 'folder.confdev' ) <= 4060 )  {
    printf( "Start Update #4060\r\n" );

    // add 
    for( $i = 0; $i < $localStore->Size( ); $i++ )  {
      $entityId = $localStore->GetEntityIdAt( $i );
      if( $localStore->GetBuild( $entityId ) <= $accessBuild )  {
        if( $localStore->GetEntityClass( $entityId ) == "timeline" )  {
          UpdateTimeline4060( $entityId );
        }      
        if( $localStore->GetEntityClass( $entityId ) == "door" )  {
          UpdateDoor4060( $entityId );
        }      
      }
    }
  }
  else {
    printf( "Skip Update #4060. Server version=%d\r\n",$accessBuild );
  }

}

/*-----------------------------------------------------------------------------
 *  UPDATE TIMELINE
 */
function UpdateTimeline4060( $entityId )
{
  global $localStore;

  $entity = $localStore->Get( $entityId );
  $name = $entity['name'];

  if( ( key_exists( 'sp', $entity ) )
   && ( !key_exists( 'timeline2', $entity['sp'] ) )
   && ( key_exists( 'timeline', $entity['sp'] ) )
    ) {
    $timelineSpAddress = $entity['sp']['timeline']['address'];
    $entity['sp']['timeline2'] = Array( 
      'label'       => $name . ' ({$aui_widget_automatic})',
      'address'     => $timelineSpAddress . "2",
      'type'        => "BOOL",
      'name'        => "timeline2",
      'persistent'  => true,
      'default'     => true,
      'driver'      => "TIMELINE"
    );
  }

  $entity = $localStore->AddPermissionRecord( $entity, "rw", "timeline2" );
  $localStore->Set( $entityId, $entity );
  //printf( "Update '%s'\r\n", $entityId );


}

/*-----------------------------------------------------------------------------
 *  UPDATE DOOR
 */
function UpdateDoor4060( $entityId )
{
  global $localStore;

  $entity = $localStore->Get( $entityId );
  $isChanged = false;

  // -- door opener --
  if( ( key_exists( 'sp', $entity ) )
   && ( key_exists( 'door', $entity['sp'] ) )
   && ( key_exists( 'resdef', $entity['sp']['door'] ) )
   && ( isset( $entity['sp']['door']['resdef'][0]['ontime'] ) )
    ) {
    $onTime    = $entity['sp']['door']['resdef'][0]['ontime'];
    $id        = $entity['sp']['door']['resdef'][0]['id'];
    $retrigger = $entity['sp']['door']['resdef'][0]['preventToggle'];
    $entity['sp']['door']['resdef'] = Array( Array( 
      'id' => $id,
      'action' => "switch",
      'periods' => "1"
    ) );
    $entity['sp']['door']['signaltime'] = $onTime;
    $entity['sp']['door']['retrigger'] = $retrigger;
    unset( $entity['sp']['door']['exception'] );
    $isChanged = true;
  }

  // -- door2 opener --
  if( ( key_exists( 'sp', $entity ) )
   && ( key_exists( 'door2', $entity['sp'] ) )
   && ( key_exists( 'resdef', $entity['sp']['door2'] ) )
   && ( isset( $entity['sp']['door2']['resdef'][0]['ontime'] ) )
    ) {
    $onTime    = $entity['sp']['door2']['resdef'][0]['ontime'];
    $id        = $entity['sp']['door2']['resdef'][0]['id'];
    $retrigger = $entity['sp']['door2']['resdef'][0]['preventToggle'];
    $entity['sp']['door2']['resdef'] = Array( Array( 
      'id' => $id,
      'action' => "switch",
      'periods' => "1"
    ) );
    $entity['sp']['door2']['signaltime'] = $onTime;
    $entity['sp']['door2']['retrigger'] = $retrigger;
    unset( $entity['sp']['door2']['exception'] );

    $isChanged = true;
  }

  // -- light ---
  if( ( key_exists( 'sp', $entity ) )
   && ( key_exists( 'light', $entity['sp'] ) )
   && ( key_exists( 'resdef', $entity['sp']['light'] ) )
   && ( isset( $entity['sp']['light']['resdef'][0]['ontime'] ) )
    ) {
    $onTime    = $entity['sp']['light']['resdef'][0]['ontime'];
    $id        = $entity['sp']['light']['resdef'][0]['id'];
    $retrigger = $entity['sp']['light']['resdef'][0]['preventToggle'];
    $entity['sp']['light']['resdef'] = Array( Array( 
      'id' => $id,
      'action' => "switch",
      'periods' => "1"
    ) );
    $entity['sp']['light']['signaltime'] = $onTime;
    $entity['sp']['light']['retrigger'] = $retrigger;

    $isChanged = true;
  }

  if( $isChanged )  {
    $localStore->Set( $entityId, $entity );
    //printf( "Update '%s'\r\n", $entityId );
  }


}