<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for G.46 (> 4503)
 *
 *  1. Add correct prim type for direct doorcalls
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update4503()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  if( FORCE || $localStore->GetBuild( 'folder.confdev' ) <= 4503 )  {
    printf( "Start Update #4503\r\n" );
    // add 
    for( $i = 0; $i < $localStore->Size( ); $i++ )  {
      $entityId = $localStore->GetEntityIdAt( $i );
      if( $localStore->GetBuild( $entityId ) <= $accessBuild )  {
        UpdateCall4503( $entityId );
      }
    }
  }
  else{
    printf( "Skip Update #4503. Server version=%d\r\n",$accessBuild );
  }

}

/*-----------------------------------------------------------------------------
 *  UPDATE TIMELINE
 */
function UpdateCall4503( $entityId )
{
  global $localStore;
  
  $entity     = $localStore->Get( $entityId );
  if( !key_exists( "deviceConfig", $entity ) )  {
    return;
  };
  //echo $entityId . "\n";
  $name       = $entity['name'];
  $mac        = isset($entity['adminUi']['macaddr'])? $entity['adminUi']['macaddr'] : null;
  $hasChanged = false;
  $toChangeSysIds = [];

  if( !isset( $mac ) || empty( $mac ) ) {
    return;
  }

  //echo $name . "\n";
  //1. Step correct the entity file ( add primType to param )
  foreach( $entity['deviceConfig'] as $configEntryNo => $keyConfig )  {
    $target;
    $primType = "call";

    if( key_exists( "in", $keyConfig ) && key_exists( "template", $keyConfig ) && $keyConfig['template'] == "call" )  {
      if( key_exists( "param", $keyConfig ) )  {
        if( !key_exists( "primType", $keyConfig['param'] ) )  {
          //echo "primType doesn't exist!\n";
          $target = $keyConfig['param']['targetEntityId'];
          $class  = $localStore->GetEntityClass( $target );
          if( $class == "door" )  {
            $primType = "doorcall";
          }
          // save sysid and prim type for xml manipulation ( {3:"call", 8:doorcall""} )
          $entity['deviceConfig'][ $configEntryNo ]['param']['primType'] = $primType;
          //echo $keyConfig['in']['sysid'] . "\n";
          $toChangeSysIds[ $keyConfig['in']['sysid'] ] = $primType;
        }
      }
    }
  }
  //print_r( $toChangeSysIds );
  // save changes
  $localStore->Set( $entityId, $entity );

  //2. create a new device xml
  //
  // it doesn't work because of the reason the sever is down until the update script is finished
  //
  //$devTpl = new DevConfigTemplates( $entityId );
  //$mac    = preg_replace( "/:/", "-", $mac);
  //$devTpl->Create( DEVCONF_PATH . strtolower( $mac ) . ".xml" );

  //2.1 get xml file
  if( file_exists( DEVCONF_PATH . $mac . ".xml" ) )  {
    $xml = simplexml_load_file( DEVCONF_PATH . $mac . ".xml" );
    //echo "xml file loaded\n";
  }
  else  {
    return;
  }
  
  //2.3 change prim type
  $settings = $xml->xpath( "//in" );
  foreach( $settings as $setting )  {
    if( key_exists( ((int)$setting->id), $toChangeSysIds ) )  {
      $setting->evt->prim['type'] = $toChangeSysIds[ (int)$setting->id ];
    }
  }
  $xml->saveXML( DEVCONF_PATH . $mac . ".xml" );

  //printf( "Update '%s'\r\n", $entityId );
}