<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for G.46 (> 4503)
 *
 *  1. Add correct prim type for direct doorcalls
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update4579()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  // add 
  if( FORCE || $localStore->GetBuild( 'folder.confdev' ) <= 4579 )  {  
    printf( "Start Update #4579\r\n" );
    for( $i = 0; $i < $localStore->Size( ); $i++ )  {
      $entityId = $localStore->GetEntityIdAt( $i );
      if( $localStore->GetBuild( $entityId ) <= $accessBuild )  {
        if( $localStore->GetEntityClass( $entityId ) == "apartment"  )  {
          UpdateCall4579( $entityId );
        }
      }
    }
  }
  else {
    printf( "Skip Update #4579. Server version=%d\r\n",$accessBuild );
  }

}

/*-----------------------------------------------------------------------------
 *  UPDATE TIMELINE
 */
function UpdateCall4579( $entityId )
{
  global $localStore;
  
  $entity     = $localStore->Get( $entityId );
  if( !key_exists( "deviceConfig", $entity ) )  {
    return;
  };
  //echo $entityId . "\n";
  $name       = $entity['name'];
  $mac        = $entity['adminUi']['macaddr'];
  $hasChanged = false;
  $toChangeSysIds = [];

  if( !isset( $mac ) || empty( $mac ) ) {
    return;
  }

  //echo $name . "\n";
  //1. Step correct the entity file ( change observeled to led )
  foreach( $entity['deviceConfig'] as $configEntryNo => $keyConfig )  {
    $sysid;
    $script;
    if( key_exists( "in", $keyConfig ) && key_exists( "template", $keyConfig ) && $keyConfig['template'] == "observerled" )  {
        //echo "observeled found!!";
        $sysid  = $entity['deviceConfig'][ $configEntryNo ]['in']['sysid'];
        $script = $entity['deviceConfig'][ $configEntryNo ]['param']['script'];
        $entity['deviceConfig'][ $configEntryNo ]['template'] = "led";
        $entity['deviceConfig'][ $configEntryNo ]['param']['lastTrigger'] = "individually" ;
        $entity['deviceConfig'][ $configEntryNo ]['param']['script']['doormatic'] = false;
    }
  }
  
  // save changes
  $localStore->Set( $entityId, $entity );
}