<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for G.46 (> 6544)
 *
 *  1. add new reboot flag to old ipdb entries
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update6544()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  if( FORCE || $localStore->GetBuild( 'folder.confdev' ) <= 6544 )  {  
    printf( "Start Update #6544\r\n" );
    Update6544UpdateIpDB();
  }
  else {
    printf( "Skip Update #6544. Server version=%d\r\n",$accessBuild );
  }
}

/*-----------------------------------------------------------------------------
 *  UPDATE IPDB
 */
function Update6544UpdateIpDB()
{
  global $localStore;

  if( file_exists( "/opt/access6/access.ini" ) )  {
    $iniFile        = parse_ini_file("/opt/access6/access.ini");
  }
  else {
    return;
  }

  $ipDb = file_get_contents( $iniFile['data'] . '/data/userdata/folder.devices.ipDb.json' );

  if( empty( $ipDb ) )  {
    return;
  }

  $jsonIpDb = json_decode( $ipDb, true );

  $jsonIpDb['meta']['fields']['reboot'] = null;
  foreach( $jsonIpDb['data'] as $key => $entry )  {
    if( isset( $entry['entid'] ) ) {
      $jsonIpDb['data'][ $key ]['reboot'] = GetRebootType( $localStore->Get( $entry['entid'] ) );
    }
  }

  file_put_contents( $iniFile['data'] . '/data/userdata/folder.devices.ipDb.json', json_encode( $jsonIpDb ) );

}

/**
 * GetRebootType
 *
 * updates the ipDb table with the reboot flag { ssh | devapi |agw }
 *
 * @param $entity
 * @return string
 */
function GetRebootType( $entity )
{
  $rebootType     = "";
  $deviceTemplate = $entity['deviceTemplate'];

  if( strpos( $deviceTemplate, "AFS" ) !== false )  {
    return "DEVAPI";
  }
  else{
    return "SSMP";
  }


  return $rebootType;
}