<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for G.46 (> 6544)
 *
 *  1. add new reboot flag to old ipdb entries
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update6691()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  if( FORCE || $localStore->GetBuild( 'folder.confdev' ) <= 6691 )  {  
    printf( "Start Update #6691\r\n" );
    // add
    for( $i = 0; $i < $localStore->Size( ); $i++ )  {
      $entityId = $localStore->GetEntityIdAt( $i );
      if( $localStore->GetBuild( $entityId ) <= $accessBuild )  {
        Update6691RepairAzio( $entityId );
      }
    }
    Update6691RepairAzio( $entityId );
  }
  else {
    printf( "Skip Update #6691. Server version=%d\r\n",$accessBuild );
  }
}

/*-----------------------------------------------------------------------------
 *  UPDATE IPDB
 */
function Update6691RepairAzio( $entityId )
{
  global $localStore;
  $entity = $localStore->Get( $entityId );

  // caution old devices  & avp & azio
  if( isset( $entity, $entity['deviceConfig'] ) && $entity['class'] == "avp" )  {
    foreach( $entity['deviceConfig'] as $key => $config )  {
      if( isset( $config['module'] ) && $config['module'] === "AZIO" )  {
        if( $config['uid'] === "ahtf_a2" )  {
          $entity['deviceConfig'][ $key ]['abbr'] = "A2";
          $entity['deviceConfig'][ $key ]['out']['sysid'] = 3;
        }

        if( $config['uid'] === "ahtf_e2" )  {
          $entity['deviceConfig'][ $key ]['abbr'] = "E2";
          $entity['deviceConfig'][ $key ]['in']['sysid'] = 92;
        }
      }
    }  // for
    $localStore->Set( $entityId, $entity );
  }


}