<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for 6.2.0 (6999)
 *
 *  - remove existing rules from devtree
 *  - remove existing configurations in entities
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update6999()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  // prevent delete of rules in test builds
  if( $accessBuild == 4711 ) {
    return;
  }

  // this is special: usually it will run everytime when current version is newer
  // REM: since here all rules are deleted, we must not force an update!
  if( FORCE_6_1 || $localStore->GetBuild( 'folder.confdev' ) < 6999 )  {

    printf( "Start Update #6999 (currentVersion=%d)\r\n", $accessBuild );

    $localStore->DeleteEntity( "rule.offline" );
    $localStore->DeleteEntity( "rule.lastdoor" );
    $localStore->DeleteEntity( "rule.alarmcall" );
  
    for( $i = 0; $i < $localStore->Size( ); $i++ ) {
      // remove rule configuration
      $entityId = $localStore->GetEntityIdAt( $i );
      Update6999Rules( $entityId );

    }
  }
  else {
    printf( "Skip update #6999 Server version=%d\r\n", $accessBuild );
  }

}

/*-----------------------------------------------------------------------------
 *  UPDATE remove all rule configuration
 */

function Update6999Rules( $entityId )
{
  global $localStore;
  $entity = $localStore->Get( $entityId );

  if( ! isset( $entity['rules'] ) ) {
    return;
  }

  unset( $entity['rules'] );
  $localStore->Set( $entityId, $entity );

}
