<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for 7.0.x (7047)
 *
 *  - add opener/opener2/light to "entrance" in doors
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update7047()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  if( FORCE || FORCE_6_1 || $localStore->GetBuild( 'folder.confdev' ) <= 7047 )  {
    printf( "Start Update #7047 (currentVersion=%d)\r\n", $accessBuild );
  
    for( $i = 0; $i < $localStore->Size( ); $i++ ) {
      // remove rule configuration
      $entityId = $localStore->GetEntityIdAt( $i );
      Update7047Door( $entityId );

    }
  }
  else {
    printf( "Skip update #7047 Server version=%d\r\n", $accessBuild );
  }

}

/*-----------------------------------------------------------------------------
 *  UPDATE remove all rule configuration
 */

function Update7047Door( $entityId )
{
  global $localStore;
  $entity = $localStore->Get( $entityId );

  if( !isset( $entity['class'] ) || $entity['class'] != "door" ) {
    return;
  }

  if( !isset( $entity['entrance']['opener'] ) && isset( $entity['sp']['door'] ) ) {
    $entity['entrance']['opener'] = $entity['sp']['door']['address'];
  }
  if( !isset( $entity['entrance']['opener2'] ) && isset( $entity['sp']['door2'] ) ) {
    $entity['entrance']['opener2'] = $entity['sp']['door2']['address'];
  }
  if( !isset( $entity['entrance']['light'] ) && isset( $entity['sp']['light'] ) ) {
    $entity['entrance']['light'] = $entity['sp']['light']['address'];
  }


  $localStore->Set( $entityId, $entity );

}
