<?php
/*-----------------------------------------------------------------------------
 *  UPDATE for 7.0.x (7060)
 *
 *  - add 'buscontroller' to lightkey in doors
 *
 *---------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
 *  MAIN - FUNCTION
 */
function Update7060()
{
  global $localStore;
  $accessBuild = intval( ACCESS_BUILD );

  if( FORCE || FORCE_6_1 || $localStore->GetBuild( 'folder.confdev' ) <= 7060 )  {
    printf( "Start Update #7060 (currentVersion=%d)\r\n", $accessBuild );
  
    for( $i = 0; $i < $localStore->Size( ); $i++ ) {
      // remove rule configuration
      $entityId = $localStore->GetEntityIdAt( $i );
      Update7060Door( $entityId );

    }
  }
  else {
    printf( "Skip update #7060 Server version=%d\r\n", $accessBuild );
  }

}

/*-----------------------------------------------------------------------------
 *  UPDATE remove all rule configuration
 */

function Update7060Door( $entityId )
{
  global $localStore;
  $entity = $localStore->Get( $entityId );

  if( !isset( $entity['class'] ) || $entity['class'] != "door" ) {
    return;
  }

  foreach( $entity['deviceConfig'] as &$deviceRecord ) {
    if( isset( $deviceRecord['uid'] ) &&  $deviceRecord['uid'] == "atlm_l" )  {
      $deviceRecord['buscontroller'] = "atlm";
    }
  }


  $localStore->Set( $entityId, $entity );

}
