<?php
//-----------------------------------------------------------------------------
//
//  AccessLib
//  (c) 2019  CYTEL Technology AG
//
//  Editor: Tobias Stumpf
//
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
//  AUTOLOAD
//-----------------------------------------------------------------------------
//external libs
include_once __DIR__ . "/external/Mustache/Autoloader.php";

//autoloader for shared sources
include_once  __DIR__ . "/lib/helpers.php";
include_once __DIR__ . "/lib/AccessLibAutoLoader.php";

AccessLibAutoLoader::Register();

//-----------------------------------------------------------------------------
//  CLASS
//-----------------------------------------------------------------------------

class
AccessLib
{

  //-----------------------------------------------------------------
  //  variables
  //-----------------------------------------------------------------

  private static $m_paths;

  //-----------------------------------------------------------------
  //  methods
  //-----------------------------------------------------------------

  /**
   * stores the given parameter from a ini file or other configurations
   * @param $config
   */
  public static function Initialize( $config )
  {
    // basic paths from *.ini
    AccessLib::$m_paths['root'] = $config['root'];
    AccessLib::$m_paths['data'] = $config['data'];
    AccessLib::$m_paths['log']  = $config['log'];

    //special paths
    AccessLib::$m_paths['tftpPath'] = AccessLib::$m_paths['root'] . "config" . DIRECTORY_SEPARATOR . "tftp-data";
  }

  /**
   * @return string returns the "root path" of a project
   */
  public static function GetRootPath()
  {
    return AccessLib::$m_paths['log'];
  }

  /**
   * @return string returns the "data path" of a project
   */
  public static function GetDataPath()
  {
    return AccessLib::$m_paths['log'];
  }

  /**
   * @return string returns the "log path" of a project
   */
  public static function GetLogPath()
  {
    return AccessLib::$m_paths['log'];
  }
}
?>
