<?php
/******************************************************************************
 *  LOG
 *  ----------------
 *  
 *  converts the tree to 'app/data/confstore/devtree.json'
 * 
 *****************************************************************************/
 
class LOG
{
  static $first = true;
  static $file = null;
  
  const FMTSYS  = " L:--- [%s] ";
  const FMTDBG  = " L:DBG [%s] ";
  const FMTWARN = " L:WRN [%s] ";
  const FMTINFO = " L:INF [%s] ";
  const FMTERR  = " L:ERR [%s] ";
  
  /*-------------------------------------------------------
   *  write a debug entry  
   */  
  static function debug( $module )
  {
    return;
    $args = func_get_args();
    LOG::_write( $module, LOG::FMTDBG, $args );
  }


  /*-------------------------------------------------------
   *  write an info  
   */  
  static function info( $module )
  {
    $args = func_get_args();
    LOG::_write( $module, LOG::FMTINFO, $args );
  }


  /*-------------------------------------------------------
   *  write a warning  
   */  
  static function warning( $module )
  {
    $args = func_get_args();
    LOG::_write( $module, LOG::FMTWARN, $args );
  }


  /*-------------------------------------------------------
   *  write an error  
   */  
  static function error( $module )
  {
    $args = func_get_args();
    LOG::_write( $module, LOG::FMTERR, $args );
  }

  /*-------------------------------------------------------
   *  create the file  
   */
  static function _create( )
  {
    //if( !is_dir( 'log' ) )  {
    //  mkdir( 'log' );
    //}
    //$fileName   = strftime( AccessLib::GetLogPath() . "Admin_%d.%m.%Y_%H.txt" );
    $fileName = LOG_PATH . "Admin_%d.%m.%Y_%H.txt";
    LOG::$file  = fopen( $fileName, 'a+' );
    LOG::$first = false;   
  }
    
  /*-------------------------------------------------------
   *  write an error  
   */  
  static function _write( $module, $fmt, $args )
  {
    if( LOG::$first == true )  {
      LOG::_create( );
    }

    $t = explode(" ",microtime());
    $tstamp = date( "d.m.Y H:i:s", $t[1] ).substr( (string)$t[0], 1, 4 );
        
    $result = '';
    if( $args[0] == $module )  {
      
      $result  = $tstamp; //strftime( "%d.%m.%Y %H:%M:%S" );
      $result .= sprintf( $fmt, $module );
      if( key_exists('REMOTE_ADDR', $_SERVER) )
        $result .= '('.$_SERVER['REMOTE_ADDR'].') ';  
      array_shift( $args ); 
    }
    else  {
      $result  = $tstamp; //strftime( "%d.%m.%Y %H:%M:%S" );
      $result .= sprintf( $fmt, "default" );
      if( key_exists('REMOTE_ADDR', $_SERVER) )
        $result .= '('.$_SERVER['REMOTE_ADDR'].') ';  
    }    

    $format = array_shift( $args ); 
    $result = $result . vsprintf( $format, $args ) . "\r\n";
    
    fwrite( LOG::$file, $result );

  }

}  
?>