<?php

/**
 * A5_RequestHandler
 *
 */
class A5_XHRStream
{

  private static $envelopeClasses = [];

  /**
   * Summary of RegisterCommand
   * @param string $command
   * @param mixed $commandClass
   */
  public static function RegisterEnvelope( $compartment, &$commandClass )
  {
    A5_XHRStream::$envelopeClasses[ $compartment ] = $commandClass;
  }

  /**
   * Summary of UnRegisterCommand
   * @param string $compartment
   */
  public static function UnRegisterEnvelope(  $compartment )
  {
    A5_XHRStream::$envelopeClasses[ $compartment ] = $commandClass;
  }

  /**
   * Summary of GetEnvelope
   * @param string $compartment e.g 'ADMIN'
   * @return XHRCommand
   */
  public static function GetEnvelope(  $compartment )
  {
    if( key_exists( $compartment, self::$envelopeClasses ) )  {
      return self::$envelopeClasses[ $compartment ];
    }
    return null;
  }
}