<?php

/**
 * Class CosConfProxy
 */
class CosConfProxy {

  public
  function __construct()
  {
  }

  //-----------------------------------------------------------------------------
  //  Read(): get the current configuration of the system network configuration
  //
  function Read()
  {
    $envelope        = new Envelope( getGUID(), "READ", SESSION::Get(), null );
    $envelopeReponse = CosConfPipe::Send( $envelope->Get( true ) );
    //echo $envelopeReponse;die( "\nresponse received\n" );
    return json_decode( $envelopeReponse, true );
  }

  //-----------------------------------------------------------------------------
  //  Write(): save current networkchanges.
  //           nothing will changed in the system before a restart will happen
  //
  function Write( $netlist )
  {
    $data = $netlist;
    $envelope = new Envelope( getGUID(), "WRITE", SESSION::Get(), $data );

    $envelopeReponse = CosConfPipe::Send( $envelope->Get(true) );
    return json_decode( $envelopeReponse, true );
  }

  //-----------------------------------------------------------------------------
  //  Apply(): apply the current networkfig => services will be restarted
  //
  function Apply( $netlist )
  {
    $data = $netlist;
    $envelope = new Envelope( getGUID(), "WRITE", SESSION::Get(), $data );
    $envelope = $envelope->Get();
    $envelope['meta']['action'] = "APPLY";

    $envelopeReponse = CosConfPipe::Send( json_encode( $envelope, JSON_UNESCAPED_UNICODE ) );
    return json_decode( $envelopeReponse, true );
  }

  //-----------------------------------------------------------------------------
  //  Resync(): discard manually changes and apply current webpage settings
  //
  function Resync()
  {
    $envelope        = new Envelope( getGUID(), "RESYNC", SESSION::Get(), null );
    $envelopeReponse = CosConfPipe::Send( $envelope->Get( true ) );
    return json_decode( $envelopeReponse, true );
  }

  //-----------------------------------------------------------------------------
  //  AcceptExpert(): description
  //
  function AcceptExpert()
  {
    $envelope        = new Envelope( getGUID(), "ACCEPT-EXPERT", SESSION::Get(), null );
    $envelopeReponse = CosConfPipe::Send( $envelope->Get( true ) );
    return json_decode( $envelopeReponse, true );
  }

  //-----------------------------------------------------------------------------
  //  TimeZoneList(): get the list of Timezones
  //
  function TimeZoneList()
  {
    $envelope        = new Envelope( getGUID(), "TZ-LIST", SESSION::Get(), null );
    $envelopeReponse = CosConfPipe::Send( $envelope->Get( true ) );
    return json_decode( $envelopeReponse, true );
  }

  //-----------------------------------------------------------------------------
  //  Resync(): discard manually changes and apply current webpage settings
  //
  function SetTime( $data )
  {
    $envelope        = new Envelope( getGUID(), "SET-TIME", SESSION::Get(), $data );
    $envelopeReponse = CosConfPipe::Send( $envelope->Get( true ) );
    return json_decode( $envelopeReponse, true );
  }  
}