<?php

//=============================================================================
//
//  LicenseProxy to communicate with the access sever license compartment
//  (c) 2021 CYTEL Technology AG
//
//  Editor: Tobias Stumpf
//          10.05.2021
//=============================================================================

/**************************************************************************
 * LicenseProxy
 *
 */
class LicenseProxy
{

  private $m_commandPrefix = "LICENSE.";

  /************************************************************************
   * __construct(  )
   */
  public function __construct(  )
  {

  }

  /***********************************************************************
   * GetLicense(  )
   *
   */
  public function GetLicense(  )
  {
    $data = Array();
    $netcardsEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "GET_LICENSES", SESSION::Get(), $data );
    $response = NamedPipe::Send( $netcardsEnvelope->Get( true ) );
    return json_decode( $response, true );
  }

  /***********************************************************************
   * UploadLicense(  )
   *
   */
  public function UploadLicense( $license )
  {
    $data = Array( "fileContents" => $license );
    $netcardsEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "LICENSE_UPLOAD", SESSION::Get(), $data );
    $response = NamedPipe::Send( $netcardsEnvelope->Get( true ) );
    return json_decode( $response, true );
  }

  /***********************************************************************
   * ActivateLicenseFile(  )
   *
   */
  public function ActivateLicenseFile( $fileName )
  {
    $data = Array( "fileName" => $fileName );
    $activateEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "ACTIVATE_LICENSE_FILE", SESSION::Get(), $data );
    $activateResponse = NamedPipe::Send( $activateEnvelope->Get( true ) );
    return json_decode( $activateResponse, true );
  }
}
?>