<?php
/**************************************************************************
 * SystemProxy
 *
 * c++ header file
 *  BVar::Container GetNetcards( );
 *  BVar::Container GetTimeZone( );
 */
class SystemProxy
{

  private $m_commandPrefix = "SYSTEM.";
  //private $m_commandPrefix = "SYSTEM/";
  const LANGUAGE_SUPPORT_ADMIN  = "ADMIN";
  const LANGUAGE_SUPPORT_DEVICE = "DEVICE";
  /************************************************************************
   * __construct(  )
   */
  public function __construct(  )
  {

  }

  /***********************************************************************
   * GetNetcards(  )
   *
   */
  public function GetNetcards(  )
  {
    $data = Array( );
    $netcardsEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "GET_NETCARDS", SESSION::Get(), $data );
    $envelopeNetcards = NamedPipe::Send( $netcardsEnvelope->Get( true ) );
    return json_decode( $envelopeNetcards, true );
  }

  /***********************************************************************
   * GetTimeZone(  )
   *
   */
  public function GetTimeZone(  )
  {
    $data = Array();
    $netcardsEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "GET_TIME_ZONE", SESSION::Get(), $data );
    $envelopeNetcards = NamedPipe::Send( $netcardsEnvelope->Get( true ) );
    return json_decode( $envelopeNetcards, true );
  }

  /***********************************************************************
   * GetNumid(  )
   *
   */
  public function GetNumid(  )
  {
    $data = Array();
    $netcardsEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "GET_NUMID", SESSION::Get(), $data );
    $numid = NamedPipe::Send( $netcardsEnvelope->Get( true ) );
    return json_decode( $numid, true );
  }

  /***********************************************************************
   * GetLicense(  )
   *
   */
  public function GetLicense(  )
  {
    $data = Array();
    $netcardsEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "GET_LICENSES", SESSION::Get(), $data );
    $response = NamedPipe::Send( $netcardsEnvelope->Get( true ) );
    return json_decode( $response, true );
  }

  /***********************************************************************
   * GetLicense(  )
   *
   */
  public function UploadLicense( $license )
  {
    $data = Array( "fileContents" => $license );
    $netcardsEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "LICENSE_UPLOAD", SESSION::Get(), $data );
    $response = NamedPipe::Send( $netcardsEnvelope->Get( true ) );
    return json_decode( $response, true );
  }

  /***********************************************************************
   * GetLanguageDevice
   *
   * @return mixed
   * @throws Exception
   */
  public function GetLanguageDevice()
  {
    $data = Array( "support" => self::LANGUAGE_SUPPORT_DEVICE );
    $languageEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "GET_LANGUAGE", SESSION::Get(), $data );
    $response = NamedPipe::Send( $languageEnvelope->Get( true ) );
    return json_decode( $response, true );
  }

  /***********************************************************************
   * GetLanguageAdmin
   *
   * @return mixed
   * @throws Exception
   */
  public function GetLanguageAdmin()
  {
    $data = Array( "support" => self::LANGUAGE_SUPPORT_ADMIN );
    $languageEnvelope = new Envelope( getGUID(), $this->m_commandPrefix . "GET_LANGUAGE", SESSION::Get(), $data );
    $response = NamedPipe::Send( $languageEnvelope->Get( true ) );
    return json_decode( $response, true );
  }
}
?>