<?php
/**************************************************************************
 * TableProxy
 *
 *
 */
class TableProxy
{

  private $m_commandPrefix = "TABLE.";
  //private $m_commandPrefix = "TABLE/";


  /************************************************************************
   * __construct(  )
   */
  public function __construct(  )
  {

  }


  /************************************************************************
   *
   * Create( $entityId, $tableId )
   *
   * @param $entityId
   * @param $tableId
   */
  public function Create( $entityId, $tableId )
  {
    $data = Array(
      "entityId" => $entityId,
      "tableId"  => $tableId
    );

    $createEnvelope        = new Envelope( getGUID(), $this->m_commandPrefix . "CREATE", SESSION::Get(), $data );
    $envelopeCreateReponse = NamedPipe::Send( $createEnvelope->Get( true ) );
    return json_decode( $envelopeCreateReponse, true );
  }


  /************************************************************************
   * Delete( $entityId, $tableId )
   */
  public function Delete( $entityId, $tableId )
  {
    $data = Array(
      "entityId" => $entityId,
      "tableId"  => $tableId
    );

    $deleteEnvelope        = new Envelope( getGUID(), $this->m_commandPrefix . "DELETE", SESSION::Get(), $data );
    $envelopeDeleteReponse = NamedPipe::Send( $deleteEnvelope->Get( true ) );
    return json_decode( $envelopeDeleteReponse, true );
  }


  /************************************************************************
   * Get( $entityId, $tableId )
   */
  public function Get( $entityId, $tableId )
  {
    $data = Array(
      "entityId" => $entityId,
      "tableId"  => $tableId
    );
    $getEnvelope        = new Envelope( getGUID(), $this->m_commandPrefix . "GET", SESSION::Get(), $data );
    $envelopeGetReponse = NamedPipe::Send( $getEnvelope->Get( true ) );
    return json_decode( $envelopeGetReponse, true );
  }


  /************************************************************************
   * Find( $entityId, $tableId, $searchMask )
   */
  public function Find( $entityId, $tableId, $searchMask )
  {
    $data = Array(
      "entityId"    => $entityId,
      "tableId"     => $tableId,
      "searchMask"  => $searchMask
    );

    $findEnvelope        = new Envelope( getGUID(), $this->m_commandPrefix . "FIND", SESSION::Get(), $data );
    $envelopeFindReponse = NamedPipe::Send( $findEnvelope->Get( true ) );
    return json_decode( $envelopeFindReponse, true );
  }


  /************************************************************************
   * AddRecord( $entityId, $tableId, $record )
   */
  public function AddRecord( $entityId, $tableId, $record )
  {
    // add GUID
    if( !isset( $record['guid'] ) )  {
      //$record['id'] = getGUID();
    }

    $data = Array(
      "entityId" => $entityId,
      "tableId"  => $tableId,
      "record"  => $record
    );

    $addRecordEnvelope        = new Envelope( getGUID(), $this->m_commandPrefix . "ADD_RECORD", SESSION::Get(), $data );
    $envelopeAddRecordReponse = NamedPipe::Send( $addRecordEnvelope->Get( true ) );
    LOG::debug( __CLASS__,"(%s) env:\n" . $addRecordEnvelope->Get(true), __LINE__ );
    return json_decode( $envelopeAddRecordReponse, true );
  }


  /************************************************************************
   * UpdateRecord( $entityId, $tableId, $record )
   */
  public function UpdateRecord( $entityId, $tableId, $record )
  {
    $data = Array(
      "entityId" => $entityId,
      "tableId"  => $tableId,
      "record"  => $record
    );

    $updateRecordEnvelope        = new Envelope( getGUID(), $this->m_commandPrefix . "UPDATE_RECORD", SESSION::Get(), $data );
    $envelopeUpdateRecordReponse = NamedPipe::Send( $updateRecordEnvelope->Get( true ) );
    return json_decode( $envelopeUpdateRecordReponse, true );
  }


  /************************************************************************
   * DeleteRecord( $entityId, $tableId, $record )
   */
  public function DeleteRecord( $entityId, $tableId, $record )
  {
    $data = Array(
      "entityId" => $entityId,
      "tableId"  => $tableId,
      "record"   => $record
    );

    $deleteRecordEnvelope        = new Envelope( getGUID(), $this->m_commandPrefix . "DELETE_RECORD", SESSION::Get(), $data );
    $envelopeDeleteRecordReponse = NamedPipe::Send( $deleteRecordEnvelope->Get( true ) );
    return json_decode( $envelopeDeleteRecordReponse, true );
  }


  /************************************************************************
   * DeleteRecordByMask( $entityId, $tableId, $searchMask )
   */
  public function DeleteRecordsByMask( $entityId, $tableId, $searchMask )
  {
    $data = Array(
      "entityId"    => $entityId,
      "tableId"     => $tableId,
      "searchMask"  => $searchMask
    );

    $deleteRecordByMaskEnvelope        = new Envelope( getGUID(), $this->m_commandPrefix . "DELETE_RECORDS_BY_MASK", SESSION::Get(), $data );
    $envelopeDeleteRecordByMaskReponse = NamedPipe::Send( $deleteRecordByMaskEnvelope->Get( true ) );
    return json_decode( $envelopeDeleteRecordByMaskReponse, true );
  }

  /***********************************************************************
   *  _List( $entityId, $tableId )
   */
  public function _List( $entityId, $tableId )
  {
    return TableProxy::Get( $entityId, $tableId );
  }

}
?>