<?php
//=============================================================================
//
//  File: $(FILE_NAME)
//  (c) 2021 by CYTEL Technology AG
//
//  Editor: Tobias Stumpf
//          $(DAY).$(MONTH).$(YEAR)
//
//  Description:
//          describe the file 
//
//=============================================================================

class AdminConfigCommandInvoker
{
  //-----------------------------------------------------------------------------
  //  InvokeCommand(): gets the current command and executes them.
  //                   in most of the case use the corresponding proxy
  //
  public static function InvokeCommand( $envelope, $command, $iniFile )
  {
    $responseEnvelope = AdminConfigCommandInvoker::PrepareResponse( $envelope );
    switch( $command ) {
      // getting predefined DHCP options
      case "DHCP_OPTIONS":
        $responseEnvelope['data'] = AdminConfig::GetDhcpOptions( $iniFile );
        return $responseEnvelope;
        break;

      // getting special admin configuration
      case "GET":
        $responseEnvelope['data'] = AdminConfig::Get( $iniFile, $envelope["data"] );
        return $responseEnvelope;
        break;

      // getting special admin configuration
      case "MODULE_LIST":
        $responseEnvelope['data'] = AdminConfig::ModuleList( $iniFile );
        return $responseEnvelope;
        break;

      // getting special admin configuration
      case "MODULE_INFO":
        $responseEnvelope['data'] = AdminConfig::ModuleInfo( $iniFile, $envelope["data"] );
        return $responseEnvelope;
        break;

      case "MODULE_GET_ENTITY":
        $responseEnvelope['data'] = AdminConfig::ModuleGetEntity( $iniFile, $envelope["data"]["module"], $envelope["data"]["entid"] );
        return $responseEnvelope;
        break;

    }
  }

  //-----------------------------------------------------------------------------
  //  PrepareResponse( $envelope ): set default value of response envelope
  //
  private static function PrepareResponse( $envelope )
  {
    $responseEnvelope                   = $envelope;
    $responseEnvelope["meta"]["status"] = "200 - Ok";
    $responseEnvelope["meta"]["param"]  = $envelope["data"];
    return $responseEnvelope;
  }
}