<?php
//=============================================================================
//
//  File: $(FILE_NAME)
//  (c) 2021 by CYTEL Technology AG
//
//  Editor: Tobias Stumpf
//          $(DAY).$(MONTH).$(YEAR)
//
//  Description:
//          describe the file 
//
//=============================================================================

class CosconfCommandInvoker {

  public static function InvokeCommand( $envelope, $command, $iniFile )
  {
    $cosConfProxy     = new CosConfProxy();
    $responseEnvelope = CosconfCommandInvoker::PrepareResponse( $envelope );
    switch( $command ) {

      case "READ":
        $resyncResult  = $cosConfProxy->Read();
        $responseEnvelope["data"] = $resyncResult['data'];
        return $responseEnvelope;

      case "TZ-LIST":
        $resyncResult  = $cosConfProxy->TimeZoneList();
        $responseEnvelope["data"] = $resyncResult["data"];
        return $responseEnvelope;   
        
      case "SET-TIME":
        $resyncResult  = $cosConfProxy->SetTime( $envelope['data'] );
        $responseEnvelope["meta"]["status"] = $resyncResult['meta']['status'];
        $responseEnvelope["data"] = Array( 'time' => time() );
        return $responseEnvelope;             

      case "WRITE":
        $resyncResult  = $cosConfProxy->Write( $envelope['data'] );
        $responseEnvelope["meta"]["status"] = $resyncResult['meta']['status'];
        $responseEnvelope["data"] = $resyncResult;
        return $responseEnvelope;

      case "APPLY":
        LOG::error( basename(__FILE__ ), "(%s) command 'APPLY' is deprecated!" , __LINE__ );

      case "RESYNC":
        $resyncResult  = $cosConfProxy->Resync();
        $responseEnvelope["data"] = $resyncResult;
        return $responseEnvelope;
    }
  }

  private static function PrepareResponse( $envelope )
  {
    $responseEnvelope = $envelope;
    $responseEnvelope["meta"]["status"] = "200 - Ok";
    return $responseEnvelope;
  }
}