<?php
//=============================================================================
//
//  File: FirstInstallInvoker
//  (c) 2021 by CYTEL Technology AG
//
//  Editor: Frank Jaekel
//          18.11.2021
//
//  Description:
//          describe the file 
//
//=============================================================================

class FirstInstallInvoker
{

  //-----------------------------------------------------------------------------
  //  InvokeCommand(): gets the current command and executes them.
  //                   in most of the case use the corresponding proxy
  //
  public static function InvokeCommand( $envelope, $command, $iniFile )
  {
    $responseEnvelope = FirstInstallInvoker::PrepareResponse( $envelope );
    switch( $command ) {
      case "STARTED":
        $isOk = SESSION::Authorize( FirstInstall::$firstAdminUser, FirstInstall::$firstAdminPassword );
        $responseEnvelope["meta"]["status"] = "200 - Ok";
        $responseEnvelope["data"] = $isOk;
        return $responseEnvelope;

      case "FINISHED":
        SESSION::DeAuthorize();
        FirstInstall::Finished( $iniFile );
        FirstInstall::RebootSystem( );
        $responseEnvelope["meta"]["status"] = "200 - Ok";
        $responseEnvelope["data"] = true;
        return $responseEnvelope;
    }
  }


  //-----------------------------------------------------------------------------
  //  PrepareResponse( $envelope ): set default value of response envelope
  //
  private static function PrepareResponse( $envelope )
  {
    $responseEnvelope                   = $envelope;
    $responseEnvelope["meta"]["status"] = "200 - Ok";
    return $responseEnvelope;
  }  
}