<?php
class HttpProxySettings
{
  /**
   * replaceRedirection
   * replaces nginx proxy configuration with the new server ip
   *
   * @param $serverIp
   */

  public static
  function replaceRedirection( $serverIp )
  {
    $escapedString = str_replace( ".", "\.", $serverIp );

    // access admin
    HttpProxySettings::replaceProxyConfiguration( "# access redirection",           $serverIp, "admin/", "", false );

    // access download page
    HttpProxySettings::replaceProxyConfiguration( "# downloads redirection",        $serverIp, "downloads/", "", false );

    // software download
    HttpProxySettings::replaceProxyConfiguration( "# interface redirection",        $serverIp, "interface/", "", false );

    // firmware download siedle devices
    HttpProxySettings::replaceProxyConfiguration( "# interface update redirection", $serverIp, "interface/update.php", "", false );

    // websocket
    HttpProxySettings::replaceProxyConfiguration( "# websocket redirection",        $serverIp, "a5/", "3123", false );
  }

  /**
   * replaceProxyConfiguration proviodes a sed command for replacing nginx proxies
   *
   * @param      $commentId
   * @param      $serverAddress
   * @param      $path
   * @param bool $isHttp
   */
  public static
  function replaceProxyConfiguration( $commentId, $serverAddress, $path, $port = "", $isHttp = false )
  {
    $httpType        = $isHttp ? "http" : "https";


    $nginxConfigFile = "/etc/nginx/sites-available/agw";

    if( file_exists( $nginxConfigFile ) )  {
      LOG::error( __CLASS__, "(%s)  nginx config is missing!!!", __LINE__ );
    }

    $serverAddress   = str_replace( ".", "\.", $serverAddress );
    $path            = str_replace( ".", "\.", $path );
    $path            = str_replace( "/", "\/", $path );

    if( !empty( $port ) ) {
      $port = ":" . $port;
    }

    if( empty( $serverAddress ) || self::isIpValid( $serverAddress ) === false )  {
      $result = shell_exec( "sudo sed -i '/" . $commentId . "/{n;s/.*/    #proxy_pass " . $httpType . ":\\/\\/" . $serverAddress . $port . "\\/" . $path . ";/}' " . $nginxConfigFile );
    }
    else  {
      $result = shell_exec( "sudo sed -i '/" . $commentId . "/{n;s/.*/    proxy_pass " . $httpType . ":\\/\\/" . $serverAddress . $port . "\\/" . $path . ";/}' " . $nginxConfigFile );
    }
    if( empty( $result ) )  {
      LOG::error( __CLASS__, "(%s) result is empty!!! ", __LINE__ );
    }
  }

  public static
  function isIpValid( $ipAddress )
  {
    $isValid = true;
    if( empty( $ipAddress ) ) $isValid = false;
    if( preg_match(  "/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/", $ipAddress ) == false ) $isValid = false;
    return $isValid;
  }
}
?>