<?php
//=============================================================================
//
//  File: $(FILE_NAME)
//  (c) 2021 by CYTEL Technology AG
//
//  Editor: frank Jaekel
//          $(DAY).$(MONTH).$(YEAR)
//
//  Description:
//          describe the file 
//
//=============================================================================

class PermissionCommandInvoker
{
  //-----------------------------------------------------------------------------
  //  InvokeCommand(): gets the current command and executes them.
  //                   in most of the case use the corresponding proxy
  //
  public static function InvokeCommand( $envelope, $command, $iniFile )
  {
    $responseEnvelope = PermissionCommandInvoker::PrepareResponse( $envelope );
    $permissionProxy  = new PermissionProxy();

    switch( $command ) {
      // permission commands
      case "GET":             return $permissionProxy->Get( $envelope['data']['inquirerEntityId'], $envelope['data']['targetStatepointAddr'] );
      case "GET_ATTRIBUTES":  return $permissionProxy->GetAttributes( $envelope['data']['inquirerEntityId'], $envelope['data']['targetStatepointAddr'] );      
      case "IS_ALLOWED":      return $permissionProxy->IsAllowed( $envelope['data']['inquirerEntityId'], $envelope['data']['targetStatepointAddr'], $envelope['data']['right'] );
    }
  }

  //-----------------------------------------------------------------------------
  //  PrepareResponse( $envelope ): set default value of response envelope
  //
  private static function PrepareResponse( $envelope )
  {
    $responseEnvelope                   = $envelope;
    $responseEnvelope["meta"]["status"] = "200 - Ok";
    $responseEnvelope["meta"]["param"]  = $envelope["data"];
    return $responseEnvelope;
  }
}
