<?php
//=============================================================================
//
//  File: $(FILE_NAME)
//  (c) 2021 by CYTEL Technology AG
//
//  Editor: Tobias Stumpf
//          $(DAY).$(MONTH).$(YEAR)
//
//  Description:
//          describe the file 
//
//=============================================================================

class SessionCommandInvoker
{
  //-----------------------------------------------------------------------------
  //  InvokeCommand(): gets the current command and executes them.
  //                   in most of the case use the corresponding proxy
  //
  public static function InvokeCommand( $envelope, $command, $iniFile )
  {
    $responseEnvelope = SessionCommandInvoker::PrepareResponse( $envelope );
    switch( $command ) {

      case "LOGIN":
        $responseEnvelope['data'] = SESSION::Authorize( $envelope['data']['user'], $envelope['data']['password'] );
        if( $responseEnvelope['data'] == false ) {
          $responseEnvelope["meta"]["status"] = "401 - Ok";
        }
        return $responseEnvelope;

      case "LOGOFF":
        $responseEnvelope['data'] = SESSION::DeAuthorize() ?? "true";
        return $responseEnvelope;

      case "STATUS":
        // Passed the 503 check above.
        $responseEnvelope["meta"]["status"] = "200 - Ok";
        return $responseEnvelope;
    }
  }

  //-----------------------------------------------------------------------------
  //  PrepareResponse( $envelope ): set default value of response envelope
  //
  private static function PrepareResponse( $envelope )
  {
    $responseEnvelope                   = $envelope;
    $responseEnvelope["meta"]["status"] = "200 - Ok";
    return $responseEnvelope;
  }
}