<?php
//=============================================================================
//
//  File: SupportCommandInvoker
//  (c) 2021 by CYTEL Technology AG
//
//  Editor: Frank Jaekel
//          18.11.2021
//
//  Description:
//          describe the file 
//
//=============================================================================

class SupportCommandInvoker
{

  //-----------------------------------------------------------------------------
  //  InvokeCommand(): gets the current command and executes them.
  //                   in most of the case use the corresponding proxy
  //
  public static function InvokeCommand( $envelope, $command, $iniFile )
  {
    $responseEnvelope = SupportCommandInvoker::PrepareResponse( $envelope );
    switch( $command ) {
      case "GET_INFORMATION":
        $responseEnvelope["meta"]["status"] = "200 - Ok";
        $responseEnvelope["data"] = Array( 
          'file' => Support::GetInformation( $iniFile )
        );
        return $responseEnvelope;
    }
  }

  //-----------------------------------------------------------------------------
  //  PrepareResponse( $envelope ): set default value of response envelope
  //
  private static function PrepareResponse( $envelope )
  {
    $responseEnvelope                   = $envelope;
    $responseEnvelope["meta"]["status"] = "200 - Ok";
    return $responseEnvelope;
  }
}