<?php
/* =============================================================================
 *
 *  download.php
 *  (c) 2021 CYTEL Technology AG
 *
 *  XHR file download interface for admin.
 * 
 *  IMPORTANT NOTE. This must be "UTF-8", not "UTF-8 with BOM"!!
 *  Otherwise those 3 BOM bytes would appear in the downloaded file!!
 *
 *  Editor: Peter Aidam
 *    created  19.08.2021 as a copy of upload.php
 * 
 * ========================================================================== */ 


//-----------------------------------------------------------------------------
//  INITIALIZE
//-----------------------------------------------------------------------------

// -- debug --
ob_start( );
$queryStart = microtime( true );

// -- include --
include_once __DIR__ . "/app/php_shared/AccessLib.php";
include_once( __DIR__ . "/app/rest_commands/AdminCommandInvoker.php" );
include_once( __DIR__ . "/app/rest_commands/AdminConfigCommandInvoker.php" );
include_once( __DIR__ . "/app/rest_commands/BackupCommandInvoker.php" );
include_once( __DIR__ . "/app/rest_commands/SessionCommandInvoker.php" );
include_once( __DIR__ . "/app/rest_commands/CosconfCommandInvoker.php" );

//-----------------------------------------------------------------------------
//  DEFINES / READ CONFIG
//-----------------------------------------------------------------------------

set_time_limit( 600 );    // 10 minutes limit

$iniFile = parse_ini_file( "../../access.ini" );
$uploadPath = $iniFile['root'] . "backup/";

if( array_key_exists( 'u', $_GET ) ) {
  $uploadPath = $iniFile['root'] . "upload/";
}

//-----------------------------------------------------------------------------
//  SESSION
//-----------------------------------------------------------------------------

SESSION::Start( false );
if( ! SESSION::IsAuthorized() )  {
  http_response_code( 401 );
  exit;
}

//-----------------------------------------------------------------------------
//  DOWNLOAD
//-----------------------------------------------------------------------------

if( $_SERVER['REQUEST_METHOD'] === 'GET' ) {

  $fileName = $_GET['file'];
  $filePath = $uploadPath . $fileName;

  // security check
  if( strstr( $fileName, ".." ) )  {
    http_response_code( 401 );
    exit;
  }
  if( strstr( $fileName, "\\" ) )  {
    http_response_code( 401 );
    exit;
  }
  if( strstr( $fileName, "/" ) )  {
    http_response_code( 401 );
    exit;
  }

  // check file itself
  if( ! file_exists( $filePath ) )  {
    http_response_code( 404 );
    exit;
  }

  // get and respond file
  header( 'Content-Type: application/octet-stream' );
  header( 'Content-Disposition: attachment; filename="' . $fileName . '"' );
  header( 'Content-Transfer-Encoding: binary' );
  readfile( $filePath );

}
else  {
  http_response_code( 405 );
}


?>