<?php
/* =============================================================================
 *
 *  exportLicense.php
 *  (c) 2021 CYTEL Technology AG
 *
 *  Download license overview xml file.
 *  Some code was copied from old admin's CommandAdmin.php.
 * 
 *
 *  Editor: Peter Aidam
 *    created  29.09.2021
 * 
 * ========================================================================== */ 


//-----------------------------------------------------------------------------
//  INITIALIZE
//-----------------------------------------------------------------------------

// -- debug --
ob_start( );
$queryStart = microtime( true );

// -- include --
include_once __DIR__ . "/app/php_shared/AccessLib.php";
include_once( __DIR__ . "/app/rest_commands/SessionCommandInvoker.php" );


//-----------------------------------------------------------------------------
//  DEFINES / READ CONFIG
//-----------------------------------------------------------------------------

set_time_limit( 600 );    // 10 minutes limit

$iniFile = parse_ini_file( "../../access.ini" );


//-----------------------------------------------------------------------------
//  SESSION
//-----------------------------------------------------------------------------

SESSION::Start( false );
if( ! SESSION::IsAuthorized() )  {
  http_response_code( 401 );
  exit;
}

//-----------------------------------------------------------------------------
//  HELPER
//-----------------------------------------------------------------------------

function getHardwareID( $numId )
{
    define( "HWVERSION", "" );
    $hardwareId = join( '-', str_split(
            str_replace('-', '', $numId), 4
        )
    );
    if( HWVERSION == ""  ) {
      return $numId;
    }
    return HWVERSION . '-' . $hardwareId;
}


//-----------------------------------------------------------------------------
//  DOWNLOAD
//-----------------------------------------------------------------------------

if( $_SERVER['REQUEST_METHOD'] === 'GET' ) {

  // Prerequisites.
  $systemProxy = new SystemProxy();
  $software    = $iniFile['version'];  
  $numId       = $systemProxy->GetNumid( );
  $numId       = $numId['data'];
  $hardwareId  = getHardwareID( $numId );
  $date        = date( "c" );
  $salt        = str_replace( ['T', '-', ':', '+'], '', $date );  
  $checksum    = hash( 'sha256', $date . $hardwareId . $software . $salt );
  $fileName    = "hwexport_" . str_replace( '-', '_', $hardwareId ) . '.xml';

  // Compose XML.
  header('Content-Type: application/download');
  header('Content-Disposition: filename=' . $fileName );
  $response = "<?xml version=\"1.0\"?>
    <Siedle>
        <Export Version=\"2\">
            <SoftwareVersion>" . $software . "</SoftwareVersion>
            <HardwareId>" . $hardwareId . "</HardwareId>
            <ExportDate>" . $date . "</ExportDate>
            <Checksum>" . $checksum . "</Checksum>
        </Export>
    </Siedle>";
    
  echo $response;

}
else  {
  http_response_code( 405 );
}

//while( @ob_end_flush( ) );

?>