<?php
//=============================================================================
//
//  Help Processor
//  (c) 2021, CYTEL
//      Frank Jaekel
//
//  Description: Simply takes a help markdown file and search for a 
//               topic (marked with character # at start of line).
//  
//=============================================================================

$time = microtime( true );

//-----------------------------------------------------------------------------
//  LOAD TOPIC
//-----------------------------------------------------------------------------

// get definied language, default is english
$language = $_GET['lang'];
if( $language != "de" && $language != "en" )  {
  $language = "en";
}

// load help file
$helpFile = file_get_contents( "help/help-" . $language . ".md" );
$helpFile = explode( "\n", $helpFile );

// find topic in help file
$topic = $_GET['topic'];
$isFound = false;

// loop though all lines, search for topic.
// returns all lines until next topic begins
foreach( $helpFile as $line )  {
  if( $isFound && $line[ 0 ] == "#" )  {
    break;
  }
  else if( $isFound ) {
    $result .= $line . "\n";
  }
  else if( strpos( $line, $topic ) !== false )  {
    $isFound = true;
  }
}
$result = trim( $result );

// error if not found
if( ! $isFound )  {
  $result = "**Error**: Topic '$topic' not found!";
}

//-----------------------------------------------------------------------------
//  FINIALIZE
//-----------------------------------------------------------------------------

$time = microtime( true ) - $time;
header( "X-Created-Time:" . $time * 1000 . " msec." );

echo $result;

?>
