# /forms/system/dashboard/hwid

Unique identifier (ID) generated from various hardware and software components that is required to order Access licences.

# /forms/system/dashboard/version

Installed software version and build number of the Access Professional system software.

# /forms/system/dashboard/numdev

Number of end devices operated in the Access system (e.g. door stations, internal call stations).

# /forms/system/dashboard/demotime

Expiry date of the 30-day demo period until which Access Professional can be used without restrictions.

# /forms/system/backup/create

Backup of the Access system configuration **without** the initial setup configuration (Network, Time zone, Credentials of the system administration).

# /forms/system/backup/upload

File selection for the restoration of the Access system configuration **without** the initial setup configuration (Network, Time zone, Credentials of the system administration).

# /forms/system/backup/file

Selected file for the restoration process.

# /forms/system/basicparam/syslang

Central selection of the language for the user interface of all Access internal call stations (10 languages).

# /forms/system/basicparam/netcard

Listing of all network adapters recognised by the Access system.

# /forms/system/basicparam/doorringtimeout

Ringing duration for a door call at an internal call station (5 - 60 seconds).

# /forms/system/basicparam/doorcalltimeout

Duration that a door call can last (1 – 1440 minutes).

# /forms/system/basicparam/latevideotimeout

Duration that a video stream is displayed at an internal call station after the call has ended (0 - 15 seconds).

# /forms/system/basicparam/ringtimeout

Ringing duration for internal and external calls at an internal call station (5 - 120 seconds).

# /forms/system/basicparam/calltimeout

Duration that an internal or external call can last (10 – 1440 minutes).

# /forms/system/basicparam/grabpic

Duration that a picture remains stored in the video memory (1 – 120 days).

# /forms/system/basicparam/timecdr

Duration that an entry remains stored in the call list (1 – 120 days).

# /forms/system/basicparam/timevoicemail

Storage duration of a voicemail message (1 – 120 days).

# /forms/system/callnumberplan/profiles

Individually nameable rule set with at least one dialling rule. 

# /forms/system/callnumberplan/permissions

Individually configurable rule(s) to allow or prohibit end devices from dialling certain numbers.

# /widget/control/password/password

Individually changeable string that is linked to a user account in the Access system or required for login purposes to devices/systems from other manufacturers.

# /widget/control/password/password2

Repeat password entry, for confirmation when entering a password.

# /forms/system/licenses/demopriod

Expiry date of the 30-day demo period until which Access Professional can be used without restrictions.

# /forms/system/licenses/grid

Overview of the licensable and licensed number of end devices (user licences) and functions (application licences) that can be operated in the system.

# /forms/system/licenses/upload

Import area for the Access Professional licence file.

# /forms/system/systemtime/srvtime

Time set in the Access system.

# /forms/system/systemtime/clitime

Time set in the computer used to access the system administration.

# /forms/system/systemtime/region

Pre-selection of a region or area to narrow down the country and time zone selection in “Time zone”.

# /forms/system/systemtime/zone

Country or time zone selection to determine the time zone and calculate the “server time” with which the Access system is operated.

# /forms/system/systemtime/timemode

Option determining how the time synchronisation of the Access systems server time is done.

# /forms/system/systemtime/ntp

Listing of the time servers or the time server pool for the automatic update of the Access systems server time.

# /forms/system/systemtime/ntpstat

Status of the automatic time synchronisation of the Access systems server time.

# /forms/system/network/widgets/controls/dns_config/mode

Option determining how the DNS configuration is done.

# /forms/system/network/widgets/controls/dns_config/list

List of all DNS servers that were manually configured or automatically transferred via DHCP.

# /forms/system/network/widgets/controls/netcard/name

Freely selectable name of the network adapter.

# /forms/system/network/widgets/controls/netcard/type

Option determining how the network adapter is configured.

# /forms/system/network/widgets/controls/netcard/ip

IPv4 address of the network adapter.

# /forms/system/network/widgets/controls/netcard/mask

Subnet mask of the network to which this network adapter is connected to.

# /forms/system/network/widgets/controls/netcard/gw

IPv4 address of the default gateway of the network to which this network adapter is connected to.

# /forms/system/network/widgets/controls/netcard/dhcp

Option determining whether to assign IPv4 addresses to Access Professional using the IP address of this network adapter as the DHCP server.

# /forms/system/network/widgets/controls/netcard/poolstart

First IP address of an IPv4 address range that is assigned via DHCP.

# /forms/system/network/widgets/controls/netcard/poolend

Last IP address of an IPv4 address range assigned via DHCP.

# /forms/system/network/widgets/controls/netcard/dhcpopt

Extended DHCP server configuration area.

# /forms/general/admin/description

Short description (e.g. “System Main-Admin”).

# /forms/general/apartment/description

Short description (e.g. “Indoor call station”) that is displayed in the Access software clients as additional information.

# /forms/general/apartment/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/asht/description

Short description (e.g. “Mobile workstation”).

# /forms/general/asht/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/avp/description

Short description (e.g. “indoor call station”) that is displayed in the Access software clients as additional information.

# /forms/general/avp/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/client/description

Short description (e.g. “Mobile workstation”).

# /forms/general/client/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/door/description

Short description (e.g. “Main entrance building 1”) that is displayed in the Access software clients as additional information.

# /forms/general/door/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/folder/description

Short description (e.g. “Building 1”).

# /forms/general/group/description

Short description (e.g. “All residents”) that is displayed in the Access software clients as additional information.

# /forms/general/group/reject

Option determining how to handle a pending group call.

# /forms/general/group/missed

Option determining how to handle an accepted group call.

# /forms/general/group/members

Listing of all end devices assigned in this group.

# /forms/general/jungpanel/description

Short description (e.g. “Control panel meeting room”) that is displayed in the Access software clients as additional information.

# /forms/general/jungpanel/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/knxgw/description

Short description (e.g. “Central building automation”).

# /forms/general/knxgw/ip

IPv4 address of the KNX gateway.

# /forms/general/knxgw/port

Network port of the network connection between the Access and KNX system.

# /forms/general/knxgw/grid

List of all KNX switching points configured in the Access system.

# /forms/general/sipaudio/description

Short description (e.g. “Telephone meeting room”) that is displayed in the Access software clients as additional information.

# /forms/general/sipaudio/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/susapp/description

Short description (e.g. “Mobile call station of the reception”) that is displayed in the Access software clients as additional information.

# /forms/general/susapp/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/susapp/qrcode

QR code for the one-time registration of a mobile end device via the Siedle app.

# /forms/general/susapp/qrstatus

Time until which the QR code can be used for the one-time registration of a mobile end device with Siedle App installed.

# /forms/general/susapp/status

Registration status of the mobile end device with Siedle App installed.

# /forms/general/timeline/description

Short description (e.g. “Opening hours main entrance”)

# /forms/general/timeline/mon

Day of the week

# /forms/general/timeline/tue

Day of the week

# /forms/general/timeline/wed

Day of the week

# /forms/general/timeline/thu

Day of the week

# /forms/general/timeline/fri

Day of the week

# /forms/general/timeline/sat

Day of the week

# /forms/general/timeline/sun

Day of the week

# /forms/general/tkgw/description

Short description (e.g. “Single channel connection PBX”).

# /forms/general/tkgw/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/tkgw/incoming

Option determining whether to forward incoming calls from the remote terminal. 

# /forms/general/tkgw/callfwd

Call forwarding to an end device or call group.

# /forms/general/tkgw/registrar

IPv4 address or host name of the remote terminal (e.g. IPv4: “192.168.178.100” or host name: “voipgate.com”).

# /forms/general/tkgw/account

Identifier (ID, user name, account name or phone number) of the SIP user account for login purposes.

# /forms/general/tkgw/framesize

Length of the audio content of RTP data packets (audio frames) to be transmitted in milliseconds.

# /forms/general/tkgw/transport

Configurable protocol (UPD, TCP, TLS) for negotiating the SIP communication parameters of the PABX connection.

# /forms/general/tkgw/port

Configurable port (1 – 65535) for negotiating the SIP communication parameters of the PABX connection.

# /forms/general/tkphone/description

Short description (e.g. “PABX system telephone reception”).

# /forms/general/tkphone/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/tkphone/gw

Selection (PABX gateway or SIP trunk), for the connection of the Access system with a remote station (e.g. telephone system) at which the PABX telephone is operated.

# /forms/general/trunk/description

Short description (e.g. “Trunk connection PABX”).

# /forms/general/trunk/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/trunk/remoteprefix

External prefix with one digit (e.g. “9”) or several digits (e.g. “99”) to identify the call origin from the Access system for the provision of further telephony features (e.g. callback via the SIP trunk) of the remote terminal.

# /forms/general/trunk/lines

Number of SIP voice channels available.

# /forms/general/trunk/ip

IPv4 address or host name of the remote terminal (e.g. telephone system).

# /forms/general/trunk/framesize

Length of the audio content of the RTP data packets (audio frames) to be transmitted in milliseconds.

# /widget/control/account

Identifier (string) linked to a user account in the Access system that is required for the login.

# /widget/control/addressBook

Assigned contact list with individually configured call destinations.

# /widget/control/callNumber

Free extension, internally assigned call number (e.g. 121) suggested by the Access system.

# /widget/control/callPrefix

System-internal prefix with one digit (e.g. “0”) or several digits (e.g. “00”) to initiate a call outside the Access system (e.g. call of a telephone in the network of the local telephone system).

# /widget/control/callProfile

Set of rules that allows or prohibits end devices from dialling certain call or telephone numbers.

# /widget/control/callWaiting

Option determining how incoming calls are handled at an end device / software client if an active call is already in progress.

# /widget/control/deviceVolume/ring

Volume of ringtone, adjustable in steps.

# /widget/control/deviceVolume/call

Volume of the voice output, adjustable in steps.

# /widget/control/deviceVolume/mic

Microphone sensitivity, adjustable in steps.

# /widget/control/dtmfDoorAndLight/door

Configured DTMF tone sequence to trigger the door opener switching function.

# /widget/control/dtmfDoorAndLight/light

Configured DTMF tone sequence to trigger the door light switching function.

# /widget/control/externCallNumber

Assigned call number of the end device in the external system without area code or prefix.

# /widget/control/keytone

Selection of whether an audio feedback is played after a door call is triggered at the door station.

# /widget/control/macAddress

Unique hardware address of an end device.

# /widget/control/mountType

Selection of the end devices mounting type to adjust the microphone behaviour (echo cancelling).

# /widget/control/showClock

Selection of whether the server time is displayed as the time on the end device.

# /widget/control/zam

Visible selection for installed status indication module (ZAM 670-…) determining wether an acoustic feedback is played in addition to the visual feedback after presing a call button at the door station. An acoustic feedback is also played at the door station for signalling the states “call”, “not available”, “open door” and “speaking”. 

# /dialog/addressEntry/label

Designation, which, depending on use, is displayed in the Access system administration and possibly also on the end devices, connected to the Access system.

# /dialog/addressEntry/callnumber

Internal or external call target.

# /dialog/addressEntry/comment

Additional information for the call target, which is displayed in the Access system administration and on the end devices.

# /dialog/changePassword/password

Password entry, to change the password.

# /dialog/changePassword/repeat

Repeated password entry, to confirm the changed password.

# /dialog/dhcpOptions/ipaddr

IPv4 address of the network adapter for which the configuration of the DHCP options is carried out.

# /dialog/dhcpOptions/mask

Subnet mask of the network to which this network adapter is connected.

# /dialog/dhcpOptions/scopestart

First IP address of an IPv4 address range assigned via DHCP.

# /dialog/dhcpOptions/scopeend

Last IP address of an IPv4 address range that is assigned via DHCP.

# /dialog/dhcpOptions/enabled

Option to enable or disable a selected DHCP option.

# /dialog/dhcpOptions/optname

Non editable information field that displays the name of the selected option.

# /dialog/dhcpOptions/value

Option-dependent value (e.g. IPv4 address or path) that may be required for DHCP configuration of an end device.

# /dialog/dhcpOptions/leases

List of all IPv4 addresses assigned via DHCP, with the option of permanently reserving an assigned IPv4 address for an end device, or releasing a reserved IPv4 address.

# /dialog/dhcpOptions/reservations

Manual configuration option for the reservation of an IPv4 address, or deletion of a manually reserved IPv4 address.

# /dialog/dhcpOptions/reservationmac

Unique hardware address of a network adapter of the end device for which an IPv4 address is manually reserved.

# /dialog/dhcpOptions/reservationip

IPv4 address reserved for this end device.

# /dialog/knxEntry/label

Label that is displayed in the Access system administration and, if applicable on the end devices that are connected to the Access system, depending on its use.

# /dialog/knxEntry/send

KNX address of a component in the KNX system to which the switching command is sent.

# /dialog/knxEntry/recv

KNX address via which the status of a component is reported back from the KNX system.

# /dialog/macAddr/macaddr

Unique hardware address that can be changed in case of an end device or user change to unregister an existing end device and allow the registration of a new end device.

# /dialog/macAddr/susreg

Option to unregister a mobile phone and delete its operating data (e.g. picture memory) when changing devices.

# /dialog/macAddr/userparam

Selectable options for deleting the various operating data sets of a end device (e.g. video memory) in the event of a user change.

# /dialog/nameCallProfile/name

Designation that is displayed in the Access system administration.

# /dialog/nameCallProfile/value

Single digit, sequence of digits, entire call number, or wildcard (also combined with digits) to explicitly allow or disallow in the dialling rule (e.g. 9, 112, 911, \*, 4\*, 800\*).

# /dialog/ntpEntry/value

IPv4 address or host name of a time server in the local network or Internet (e.g. IPv4: “10.20.30.40” or host name: “pool.ntp.org”).

# /dialog/permissions/who

Rights management area, to select objects (e.g. other end devices) that are allowed to Access selected functions of this end device according to the configured rights.

# /dialog/permissions/what

Rights management area, to enable or disable functions of this end device for selected objects (e.g. end devices).

# /widget/deviceFunctions/building_automation_url/url

URL address (with or without login data), for calling up a building automation server.

# /widget/deviceFunctions/callcontact/contact

Selection of any switching point (e.g. switching contact or time profile) to be triggered when the configured call situation arrives at the end device where the call contact was configured.

# /widget/deviceFunctions/callcontact/turnon

Selectable trigger that activates the switching point (e.g. when the call starts).

# /widget/deviceFunctions/callcontact/turnoff

Selectable trigger that deactivates the switching point (e.g. when the call ends).

# /widget/deviceFunctions/callcontact/options

Options determining in which cases the call contact should be triggered.

# /widget/control/label

Label to be displayed in the Access system administration.

# /widget/deviceFunctions/door/output

Selectable option determining whether the switching contact to be triggered is located locally at the Access door loudspeaker controller with a power supply unit for which this function is configured or is located at any other end device within the Access system.

# /widget/deviceFunctions/door/outputextern

Selection of the switching contact of any other end device within the Access system that is triggered for this function.

# /widget/deviceFunctions/door/outputlocal

Selection of the switching contact of the “Access door loudspeaker controller with line rectifier” that is triggered for this function, for which this function is configured.

# /widget/deviceFunctions/door/timeout

Time how long a triggered switching contact remains in the configured switching state (idle state/working state) (Manual / 0.4 s / 1–59 s / 1–10 min / 15–20–…–55 min / 1–2 h).

# /widget/deviceFunctions/door/options

Options to swap the switching state (idle state/working state) of a switching contact (ON becomes OFF / OFF becomes ON), and to extend the switching duration of a switching contact that is already in the triggered switching state (e.g. working state) by the configured switching duration when it is triggered again (e.g. another button press).

# /widget/deviceFunctions/door/cancelcall

Option to automatically end a pending door call or a conducted door conversation by triggering a switching contact.

# /widget/deviceFunctions/door2/usefor

Selection of all devices authorised for this switching function (no groups).

# /widget/deviceFunctions/doormatic/time

Time after a triggered door call (0 – 10 seconds after pressing the call button) by which a Doormatic function triggers the switching contact (e.g. door opener contact) with a delay.

# /widget/deviceFunctions/doormatic/openafter

Time after a triggered door call (0 – 10 seconds after pressing the call button) after which a Doormatic function triggers the switching contact (e.g. door opener contact) with a delay.

# /widget/deviceFunctions/doormatic/openof

Selectable option determining which switching contacts (e.g. door opener contact) are triggered when a door call is made to the end device on which this configuration has been made.

# /widget/deviceFunctions/doormatic/doorlist

Area to manually add switching contacts (e.g. door opener contact) that are triggered by this function.

# /widget/deviceFunctions/grabpic/time

Time after a triggered door call (2 – 30 seconds after pressing the call button) until a camera image of the video door station is stored, if the called indoor call station is configured for automatic video memory.

# /widget/deviceFunctions/grabpic/mode

Record images manually only: Image recording only after request at the device. Record images automatically: Image recording automatically with every door call.

# /widget/deviceFunctions/grabpic/calls

Options in which cases an image is stored in the video memory.

# /widget/deviceFunctions/light/output

Selectable option whether the switching contact to be triggered is located locally at the Access door loudspeaker controller with line rectifier for which this function is configured or at any other end device within the Access system.

# /widget/deviceFunctions/light/outputextern

Selection of the switching contact of any other end device within the Access system that is triggered for this function. The selection depends on the option selected for “Switching contact”.

# /widget/deviceFunctions/light/outputlocal

Selection of the switching contact of the Access door loudspeaker controller with line rectifier that is triggered for this function, for which this function is configured.

# /widget/deviceFunctions/light/timeout

Time how long a triggered switching contact remains in the configured switching state (idle state/working state) (Manual / 0.4 s / 1–59 s / 1–10 min / 15–20–…–55 min / 1–2 h).

# /widget/deviceFunctions/light/options

Options to swap the switching state (idle state/working state) of a switching contact (ON becomes OFF / OFF becomes ON), and to extend the switching duration of a switching contact that is already in the triggered switching state (e.g. working state) by the configured switching duration when it is triggered again (e.g. another keystroke).

# /widget/deviceFunctions/videourl/format

Selectable option determining which format is provided for the video stream transmission to the end device.

# /widget/deviceFunctions/videourl/frames

Selectable option determining with which transmission quality the video stream is transmitted to the end device.

# /widget/deviceFunctions/videourl/security

Option to secure access to the video stream of the Access system.

# /widget/deviceFunctions/videourl/participant

Freely selectable user name for the authentication to retrieve the video stream.

# /widget/deviceFunctions/videourl/password

Freely selectable password for the authentication to retrieve the video stream.

# /widget/deviceFunctions/videourl/password2

Repeated password entry, to confirm the changed password.

# /widget/deviceFunctions/videourl/url

URL address for the retrieval of the video stream.

# /widget/deviceConfig/call/number

Internal call destination (end device or group) that is called.

# /widget/deviceConfig/doorcall/number

Internal call destination (end device or group) that is called.

# /widget/deviceConfig/externcall/number

External call destination that is called.

# /widget/deviceConfig/ldlight/timebased

Time how long a door light contact can still be triggered during a pending door call, a conducted door call, or after the last conducted door call has ended (1 – 120 minutes).

# /widget/deviceConfig/ldopener/timebased

Time how long a door opener contact can still be triggered during a pending door call, a conducted door call, or after the last conducted door call has ended (1 – 120 minutes).

# /widget/deviceConfig/led/color

Configurable colour (yellow, red) of the visual feedback of a button when a triggered event occurs.

# /widget/deviceConfig/led/trigger

Selectable option of which feedback is displayed when a triggered event occurs.

# /widget/deviceConfig/led/type

Selection of an individually configurable function / event, the occurrence of which is displayed visually as status with the LED key feedback.

# /widget/deviceConfig/led/statepoint

Selection of an object (e.g. end device or time profile) with the function / event to be monitored.

# /widget/deviceConfig/led/target

Selection of the call forwarding target to be monitored.

# /widget/deviceConfig/setdnd/target

Device on which this function is activated.

# /widget/deviceConfig/setdnd/value

Switching command that is executed when triggered.

# /widget/deviceConfig/setdoormatic/target

Device on which this function is activated.

# /widget/deviceConfig/setdoormatic/value

Switching command that is executed when triggered.

# /widget/deviceConfig/setredir/target

Device on which this function is executed.

# /widget/deviceConfig/setredir/target2

Call destination (end device, group or external number) that will be called in case of call forwarding.

# /widget/deviceConfig/setredir/type

Type of call redirection.

# /widget/deviceConfig/setredir/time

Time in seconds after which call redirection takes place for a pending call (0 – 120 seconds).

# /widget/deviceConfig/setredir/timelinevalue

Switching command that is executed when triggered.

# /widget/deviceConfig/setsp/target

Switching point (e.g. switching contact of a end device) that is triggered.

# /widget/deviceConfig/setsp/value

Switching command that is executed when triggered.

# /widget/deviceConfig/setspknx/gw

Interface to the KNX system via which switching commands are sent and, if necessary, status feedback is received.

# /widget/deviceConfig/setspknx/grpaddr

KNX address of a component in the KNX system to which the switching command is sent.

# /widget/deviceConfig/setspknx/recv

KNX address used to report the status of a component from the KNX system.

# /widget/deviceConfig/setspknx/value

Switching command that is executed in the KNX system.

# /widget/deviceConfig/storeycall/target

Device or group on which this function is executed/triggered.

# /widget/deviceConfig/storeycall/opener

Door opener contact triggered by a called end device or by a called end device of a call group.

# /widget/deviceConfig/storeycall/light

Door light contact that can be triggered by a called end device or by a called end device of a call group.

# /widget/deviceConfig/switchcontact/invert

Option to swap the switching state (idle state/working state) of a switching contact (ON becomes OFF / OFF becomes ON).

# /widget/deviceConfig/timeswitchcontact/time

Time how long a triggered switching contact remains in the configured switching state (idle state/working state) (Manual / 0.4 s / 1–59 s / 1–10 min / 15–20–…–55 min / 1–2 h).

# /widget/deviceConfig/timeswitchcontact/invert

Option to swap the switching state (idle state/working state) of a switching contact (ON becomes OFF / OFF becomes ON).

# /widget/deviceConfig/timeswitchcontact/posttrigger

Option to extend the switching duration of a switching contact that is already in the triggered switching state (e.g. working state) by the configured switching duration when it is triggered again (e.g. another keystroke).

# /widget/control/entityName/name

Designation that is displayed in the Access system management.

# /widget/commandGroup/function

Area for switching points to be configured (e.g. a switching contact or the “Do not disturb” function) that are to be controlled by time.

# /widget/deviceConfig/observerledknx/ledcolor

Configurable colour (yellow, red) of the visual feedback of a button when a triggered KNX event occurs.

# /widget/deviceConfig/observerledknx/gateway

Interface to the KNX system via which status feedback is received.

# /widget/deviceConfig/observerledknx/grpaddr

KNX address (feedback object) via which the status of a component is reported back from the KNX system.

# ------------------- Wizard topics ------------------- 

# /pages/install/networkDns

IP address of the DNS server of the network to which this network adapter is connected to. 

# /pages/install/networkInterface/type

Option determining how to configure the network adapter.

# /pages/install/networkInterface/ip

IPv4 address of the network adapter.

# /pages/install/networkInterface/mask

Subnet mask of the network to which this network adapter is connected.

# /pages/install/networkInterface/gateway

IPv4 address of the default gateway of the network to which this network adapter is connected.

# /pages/install/networkInterface/dhcpserver

Option whether Access Professional is operated as a DHCP server with this network adapter.

# /pages/install/networkInterface/poolstart

First IP address of an IPv4 address range that is assigned via DHCP.

# /pages/install/networkInterface/poolend

Last IP address of an IPv4 address range assigned via DHCP.

# /pages/install/password/admin

Identifier (string) tied to a user account in the Access system and required to login to the system.

# /pages/install/password/password

Individually changeable string that is linked to a user account in the Access system and is required to login to the system.

# /pages/install/password/password2

Repeat password entry, to confirm the changed password.

# /pages/install/timezone/region

Preselection of a region or area, to narrow down the country and time zone selection in “Time zone”.

# /pages/install/timezone/zone

Country or time zone selection (e.g. “Germany (most areas)”), to determine the time zone and calculate the “Server time” with which the Access system is operated.

# /forms/system/supportcontract

Time at which the maintenance contract ends. All releases with the major release valid at that time and all associated minor/micro releases can be installed free of charge at any time. The initial term of the maintenance contract is 1 year and can be extended for a fee.

# /widget/control/ringtone

Option to change the default ringtones for door calls, storey calls and standard calls (internal/external calls) on this device.

# /widget/control/ringtone/doorcall

Individually configurable ringing tone (audio signalling on the end device) for incoming door calls.

# /widget/control/ringtone/storeycall

Individually configurable ringing tone (audio signalling at the end device) for incoming storey calls.

# /widget/control/ringtone/default

Individually configurable ringing tone (audio signalling at the end device) for incoming standard calls (internal/external calls).

# /forms/system/dashboard/susstatus

Connection status between the Access server and the Siedle App Service (Cloud).

# /forms/system/rules/grid

Listing of all available functions of the Access system.

# /forms/system/rules/upload

File selection for the import of new function modules.

# /forms/general/ipcam/description

Short description (e.g. "camera parking area") that is displayed in the Access software clients as additional information.

# /forms/general/ipcam/devtype

Non-changeable information field indicating the device type (hardware end device, software client or app).

# /forms/general/ipcam/ip

IPv4 address or host name of the IP camera.

# /forms/general/ipcam/port

ONVIF port of the IP camera.

# /forms/general/ipcam/useauth

Option if authentication with user name and password is required to access the IP camera.

# /forms/general/ipcam/username

Default identifier (ONVIF user) for logging in to the IP camera.

# /forms/general/ipcam/streams

Video streams provided by the IP camera in different resolutions and compression formats.

# /forms/general/trunk/port

Configurable port (1 – 65535) for negotiating the SIP communication parameters of the PABX connection.

# /widget/deviceFunctions/doormatic/opener

Selection of the door opener for the doormatic function.

# /widget/control/doorCamera

Feedback to this door station whether a door camera has been detected or not.

# /forms/system/basicparam/deviceoutage_time

Time in minutes before a fault message is triggered for a failed unit.

# /forms/system/basicparam/deviceoutage_contact

Selection of any switching point (e.g. switching contact or time profile) that is to be triggered in the event of a fault message if a device failure has been detected in terminal devices with active failure detection.

# /widget/deviceFunctions/doormatic/options

"For storey calls": Doormatic is executed on the device in case of a storey call. "During call signalling only": Doormatic is only executed if the call is not answered.

# /forms/system/api/enable

Option to provide shared camera video streams of the access system in the network via ONVIF.

# /forms/system/api/onvifuser

Preset identifier (ONVIF user) for access to shared cameras of the Access system.

# /widget/deviceFunctions/onvif/profile

Name of the profile under which this camera appears in the ONVIF camera share. 

# /widget/deviceFunctions/onvif/resolution

Number of video pixels (horizontal x vertical) incl. video compression method (e.g. "1280 x 720 (H.264)").
