﻿//=============================================================================
//
//  Cookies
//  (c) 2021 CYTEL Technology AG
//
//  Description: Simplified Get/Set cookies
//
//  Editor: Peter Aidam
//          08.06.2021
//=============================================================================

class SimpleCookies
{
  //-----------------------------------------------------------------
  //  SINGLETON 
  //  
  static Instance()
  {
    if( ! ( $.app._theSimpleCookies instanceof SimpleCookies ) )  {
      $.app._theSimpleCookies = new SimpleCookies;
    }
    return $.app._theSimpleCookies;
  }


  //-----------------------------------------------------------------
  //  COOKIE Interface
  //-----------------------------------------------------------------

  Get( name )
  {
    let cookiePath = ( window.location.pathname ).slice( 0, -1 );
    return Cookies.get( name, { path: cookiePath } );
  }

  Remove( name )
  {
    let cookiePath = ( window.location.pathname ).slice( 0, -1 );
    Cookies.remove( name, { path: cookiePath } );
  }  

};
