﻿<?php
/* =============================================================================
 *
 *   XHR-Interface to admin 
 * 
 * ========================================================================== */ 

 //-----------------------------------------------------------------------------
//  INITIALIZE
//-----------------------------------------------------------------------------

// -- debug --
ob_start( );
$queryStart = microtime( true );

// -- include --
include_once __DIR__ . "/app/php_shared/AccessLib.php";
include_once( __DIR__ . "/app/rest_commands/AdminCommandInvoker.php" );
include_once( __DIR__ . "/app/rest_commands/AdminConfigCommandInvoker.php" );
include_once( __DIR__ . "/app/rest_commands/BackupCommandInvoker.php" );
include_once( __DIR__ . "/app/rest_commands/SessionCommandInvoker.php" );
include_once( __DIR__ . "/app/rest_commands/CosconfCommandInvoker.php" );

//-----------------------------------------------------------------------------
//  DEFINES / READ CONFIG
//-----------------------------------------------------------------------------

set_time_limit( 600 );    // 10 minutes upload limit
$wwwRoot = pathinfo( __FILE__ )['dirname'] . "/";

$iniFile = parse_ini_file( "../../access.ini" );
$uploadPath = $iniFile['root'] . "upload/";

define( "LOG_PATH", $iniFile['log'] );

// Access backup files only!
$extensionWhiteList = Array(
  "backup"
);

//-----------------------------------------------------------------------------
//  SESSION
//-----------------------------------------------------------------------------

SESSION::Start( false );
if( ! SESSION::IsAuthorized() )  {
  http_response_code( 401 );
  exit;
}

//-----------------------------------------------------------------------------
//  UPLOAD
//-----------------------------------------------------------------------------

if( $_SERVER['REQUEST_METHOD'] === 'PUT' ) {

  $fileName = $_SERVER['HTTP_X_FILE_NAME'];
  
  // check if upload file is valid
  if( strpos( $fileName, ".." ) !== false || strpos( $fileName, ":" ) !== false )  {
    http_response_code( 405 );
    exit;
  }

  // add out internal path
  $fileName = $uploadPath . $fileName;
  $path_parts = pathinfo( $fileName );

  // check extension whitelist
  $extension = strtolower( $path_parts['extension'] );
  if( ! in_array( $extension, $extensionWhiteList ) )  {
    http_response_code( 405 );
    exit;
  }


  // start upload -> write into temp file on server
  $inputHandle  = fopen( 'php://input', 'r' );
  $fileNameTemp = $fileName . ".upload";  
  $fileHandle = fopen( $fileNameTemp, "w+" );

  while( $chunk = fread( $inputHandle, 1024 ) )  {
    fwrite( $fileHandle, $chunk );
  }

  fclose( $fileHandle );

  $fileNameFinal = $uploadPath . "access.backup";

  // finally rename file to desired name
  unlink( $fileNameFinal );
  if( rename( $fileNameTemp, $fileNameFinal ) == false )  {
    http_response_code( 405 );
    exit;    
  }
  http_response_code( 200 );
  
}
else  {
  http_response_code( 405 );
}


?>