﻿<?php
/* =============================================================================
 *
 *   XHR-Interface to admin 
 * 
 * ========================================================================== */ 

 //-----------------------------------------------------------------------------
//  INITIALIZE
//-----------------------------------------------------------------------------
error_reporting( E_ALL );

// -- debug --
ob_start( );
$queryStart = microtime( true );

// -- include --
include_once __DIR__ . "/app/php_shared/AccessLib.php";
include_once __DIR__ . "/app/rest_commands/moduleFile.php";

//-----------------------------------------------------------------------------
//  DEFINES / READ CONFIG
//-----------------------------------------------------------------------------

set_time_limit( 600 );    // 10 minutes upload limit
$wwwRoot = pathinfo( __FILE__ )['dirname'] . "/";

$iniFile = parse_ini_file( "../../access.ini" );
$uploadPath = $iniFile['root'] . "upload/";
$modulePath = $iniFile['root']  . "config/modules/";
$certPath = $iniFile['root']  . "config/cert/";


define( "LOG_PATH", $iniFile['log'] );

// xml files only!
$extensionWhiteList = Array(
  "modpk"
);

//-----------------------------------------------------------------------------
//  SESSION
//-----------------------------------------------------------------------------

SESSION::Start( false );
if( ! SESSION::IsAuthorized() )  {
  http_response_code( 401 );
  exit;
}


//-----------------------------------------------------------------------------
//  UPLOAD
//-----------------------------------------------------------------------------

if( $_SERVER['REQUEST_METHOD'] === 'PUT' ) {

  $fileName = $_SERVER['HTTP_X_FILE_NAME'];
  
  // check if upload file is valid
  if( strpos( $fileName, ".." ) !== false || strpos( $fileName, ":" ) !== false )  {
    http_response_code( 405 );
    exit;
  }

  // add out internal path
  $uploadFileName = $uploadPath . $fileName;
  $path_parts = pathinfo( $fileName );

  // check extension whitelist
  $extension = strtolower( $path_parts['extension'] );
  if( ! in_array( $extension, $extensionWhiteList ) )  {
    http_response_code( 405 );
    exit;
  }


  // start upload -> write into temp file on server
  $inputHandle  = fopen( 'php://input', 'r' );
  $fileNameTemp = $uploadFileName . ".upload";  
  $fileHandle = fopen( $fileNameTemp, "w+" );
  while( $chunk = fread( $inputHandle, 1024 ) )  {
    fwrite( $fileHandle, $chunk );
  }
  fclose( $fileHandle );

  // finally unpack the uploaded module file
  $module = new ModuleFile( $certPath . "modules.pem" );
  $data = $module->Unpack( $fileNameTemp, $modulePath );
  $dataString = "";
  foreach( $data as $key => $value )  {
    if( gettype( $value ) == "boolean" || gettype( $value ) == "integer" ) {
      $value = json_encode( $value );
    }
    $dataString .= $key . "=" . $value . "; ";
  }

  // tidy up and return
  unlink( $fileNameTemp );
  header( "X-Access-Module-Info:" . $dataString );
  http_response_code( 200 );
  
}
else  {
  http_response_code( 405 );
}


?>