<?php
 class DevConfig extends RequestHandler implements IGetHttpRequest { public function __construct( $requestParameters ) { parent::__construct( $requestParameters ); $this->configProxy = new ConfigProxy(); $this->adminProxy = new AdminProxy(); $this->systemProxy = new SystemProxy(); $this->tableProxy = new TableProxy(); $this->presenceProxy = new PresenceProxy(); $this->PrepareDeviceSession(); $this->entity = $this->GetEntityFromServer(); } function GetInformation(): string { $resultXml = false; $resultXml = $this->CreateXml(); $this->presenceProxy->SetDeviceStatus( $this->entity['entid'], "DEVSTART", $_SERVER['REMOTE_ADDR'] ); return $resultXml; } function CreateXml() { $deviceXmlBuilder = new DeviceXmlBuilder( $this->entity ); $regtimes = $this->configProxy->Get( "admui.param" )['data']; $regtimes = $regtimes['regtimes']; $xmlString = $deviceXmlBuilder->RenderXml(); $xmlString = preg_replace( "/%currentIp%/", $this->serverIp, $xmlString ); $xmlString = preg_replace( "/%regdelaymin%/", $regtimes['regdelaymin'], $xmlString ); $xmlString = preg_replace( "/%regdelaymax%/", $regtimes['regdelaymax'], $xmlString ); $xmlString = preg_replace( "/%regfailmin%/", $regtimes['regfailmin'], $xmlString ); $xmlString = preg_replace( "/%regfailmax%/", $regtimes['regfailmax'], $xmlString ); $doc = new DOMDocument; $doc->preserveWhiteSpace = FALSE; $doc->formatOutput = true; $doc->loadxml( $xmlString ); $xPath = new DOMXPath( $doc ); if( $this->IsQModeEnabled() ) { $this->AddQmode( $doc, $xPath ); } $this->UpdateIpDb(); $this->DeleteMessages(); if( $this->entity['class'] === "jungpanel" ) { $this->AddJungPanelCurrentStatepointList( $this->entity, $doc, $xPath ); } return $doc->saveXML(); } function IsQModeEnabled() { if( file_exists( DATA_PATH . "/data/preinstall.json" ) ) { $preInstallInformation = file_get_contents( DATA_PATH . "/data/preinstall.json" ); $json = json_decode( $preInstallInformation, true ); return $json['params']['q_mode']; } if( file_exists( DATA_PATH . "/data/confstore/module.asolis.json" ) ) { return true; } return false; } function AddQmode( &$doc, &$xPath ) { $qmodeXml = $doc->createDocumentFragment(); $qmodeXml->appendXML( '<comp id="CLI"><clicfg><clistate>on</clistate><cliclientport>60200</cliclientport><clitestport>61200</clitestport></clicfg></comp>' ); $compcfg = $xPath->evaluate( "//compcfg" )[0]; $compcfg->appendChild( $qmodeXml ); } function AddJungPanelCurrentStatepointList( $entity, &$doc, &$xPath ) { if( $entity['class'] === "jungpanel" ) { $currentStatepointList = $doc->createDocumentFragment(); $currentStatepointList->appendXML( '<currentStatepointList id="GUI"></currentStatepointList>' ); $compcfg = $xPath->evaluate( "/siedle/config/compcfg/comp[2]" )[0]; $compcfg->appendChild( $currentStatepointList ); $currentStatepointListXML = $xPath->evaluate( "/siedle/config/compcfg/comp[2]/currentStatepointList" )[0]; foreach( $entity['sp'] as $key => $statepoint ) { $currentStatepointList = $doc->createDocumentFragment(); $currentStatepointList->appendXML( '<' . $key . '>' . $statepoint['address'] . '</' . $key . '>' ); $currentStatepointListXML->appendChild( $currentStatepointList ); } } } function UpdateIpDb() { $tableEntid = "folder.devices"; $tableName = "ipDb"; $response = $this->tableProxy->Create( $tableEntid, $tableName ); if( !$response['data'] ) { $record = array( "ip" => $_SERVER['REMOTE_ADDR'], "mac" => str_replace( ":", "-", $this->mac ), "entid" => $this->entityId, "created" => time(), "updated" => time(), "pending_reboot" => null, "reboot" => ( $this->agw == null ) ? "SSH" : "AGW" ); $result = $this->tableProxy->UpdateRecord( $tableEntid, $tableName, $record ); if( !$result['data'] ) { unset( $record['created'] ); $result = $this->tableProxy->AddRecord( $tableEntid, $tableName, $record ); } LOG::debug( __CLASS__, "(%s) update entid, ip in folder.devices.ipDb:" . var_export( $result, true ), __LINE__ ); } else { $record = array( "ip" => $_SERVER['REMOTE_ADDR'], "mac" => str_replace( ":", "-", $this->mac ), "entid" => $this->entityId, "created" => time(), "updated" => time(), "pending_reboot" => null, "reboot" => ( $this->agw == null ) ? "SSH" : "AGW" ); $result = $this->tableProxy->AddRecord( $tableEntid, $tableName, $record ); if( $result['data'] === false ) { $this->tableProxy->UpdateRecord( $tableEntid, $tableName, $record ); } } } function DeleteMessages() { $foundMessages = $this->tableProxy->Find( "folder.admin", "messages", array( "msgid" => "DEVRESTART_NEEDED" ) ); if( isset( $foundMessages, $foundMessages['data'] ) && $foundMessages['data'] && is_array( $foundMessages['data'] ) && !empty( $foundMessages['data'] ) ) { $foundMessages = $foundMessages['data']; foreach( $foundMessages as $key => $foundMessage ) { if( $foundMessage['entid'] == $this->entityId ) { $this->tableProxy->DeleteRecord( "folder.admin", "messages", $foundMessage ); } } } } }