<?php
 class DeviceXmlBuilder { private $entity; private $mustacheRenderer; private $mustacheParameter; private $xmlWdigetsToApply; private $templateList; private $configProxy; public function __construct( $entity ) { $this->configProxy = new ConfigProxy(); $this->entity = $entity; $this->entityId = $entity['entid']; $this->parent = $this->configProxy->Get( $this->entity['parent'] )['data']; $this->license = $this->configProxy->Get( "admui.license.json" )['data']; $this->xmlWdigetsToApply = Array(); $this->mustacheRenderer = new Mustache_Engine; $this->PrepareMustacheParameter(); } public function GetEntity() { return $this->entity; } public function getXmlWdigetsToApply(): array { return $this->xmlWdigetsToApply; } function RenderXml() : string { $templatePath = dirname( __FILE__ ) . "/XML Templates/" . $this->entity['deviceTemplate'] .".output.xml"; $deviceTemplateXml = file_get_contents( $templatePath ); $deviceTemplateXml = $this->mustacheRenderer->render( $deviceTemplateXml, $this->mustacheParameter ); $deviceTemplateXml = simplexml_load_string( $deviceTemplateXml ); foreach( $this->entity['deviceConfig'] as $numberConfigEntry => $currentConfig ) { if( isset( $currentConfig['template'] ) ) { $currentTemplate = $this->renderWidget( $currentConfig ); if( $currentTemplate !== false ) { array_push( $this->xmlWdigetsToApply, $currentTemplate ); } } } $alreadyCreatedStatePoint = Array(); foreach( $this->xmlWdigetsToApply as $key => $widgetXml ) { $widgetXml = simplexml_load_string( $widgetXml ); foreach( $widgetXml->xpath( "//insert" ) as $key => $insertXml ) { $insertPath = (String) $insertXml['xpath']; $isstatePoint = $insertXml['stptaddr'] ?? false; $appendTo = $deviceTemplateXml->xpath( $insertPath )[0]; if( $isstatePoint !== false ) { $parent = $insertXml; if( isset( $alreadyCreatedStatePoint[ $isstatePoint . "" ] ) ) { $this->appendSimpleXmlNodes( $alreadyCreatedStatePoint[ $isstatePoint . "" ], $insertXml->children()[0] ); } else { $newStpt = $parent->addChild( "stpt" ); $newStpt->addChild( "stptaddr", $isstatePoint ); $this->appendSimpleXmlNodes( $newStpt, $insertXml->children()[0] ); $this->appendSimpleXmlNodes( $appendTo, $newStpt ); $stptNodes = $deviceTemplateXml->xpath( "/siedle/config/stptcfg/stpt" ); $alreadyCreatedStatePoint[ $isstatePoint . "" ] = $stptNodes[ sizeof( $stptNodes ) - 1 ]; } } else{ if( $insertXml->count() > 0 ) { $this->appendSimpleXmlNodes( $appendTo, $insertXml->children() ); } } } } $doc = new DOMDocument; $doc->preserveWhiteSpace = FALSE; $doc->formatOutput = true; $doc->loadxml( $deviceTemplateXml->asXML() ); return $doc->saveXML();; } function RenderWidget( $config ) { if( !isset( $config['template'] ) || empty( $config['template'] ) ) { return false; } $xmlWidgetTemplate = $this->GetWidgetTemplate( $config['template'] ); if( $xmlWidgetTemplate === false ) { return false; } $this->mustacheParameter['current'] = $config; $this->mustacheParameter['module'] = Array(); $this->mustacheParameter['module'][ $config['module'] ] = true; $this->mustacheParameter['module'][ $config['template'] ] = true; if( $config['module'] == "AZIO" ) { $this->mustacheParameter['module']['IO'] = true; $this->mustacheParameter['module']['sensor'] = true; } if( $config['module'] == "function" ) { $this->mustacheParameter['function'] = true; } if( $this->mustacheParameter['current']['module'] == "KBD" ) { if( $this->mustacheParameter["current"]["trigger"] == "pos" || $this->mustacheParameter["current"]["trigger"] == "neg" ) { $this->mustacheParameter['module']["edgeTriggered"] = true; } else { $this->mustacheParameter['module']["edgeTriggered"] = false; } } if( $this->mustacheParameter['current']['module'] == "IO" ) { if( key_exists( "trigger", $this->mustacheParameter["current"] ) && $this->mustacheParameter["current"]["trigger"] == "sensor" ) { $this->mustacheParameter['module']["sensor"] = true; } else { $this->mustacheParameter['module']["sensor"] = false; } } return $this->mustacheRenderer->render( $xmlWidgetTemplate, $this->mustacheParameter ); } function GetWidgetTemplate( $template ) { $widgetTemplatePath = dirname( __FILE__ ) . "/WidgetTemplates/" . $template . ".devtpl.xml"; $deviceTemplatePath = dirname( __FILE__ ) . "/XML Templates/" . $this->entity['deviceTemplate'] . ".templates.xml"; if( file_exists( $deviceTemplatePath ) ) { $deviceTemplates = simplexml_load_file( $deviceTemplatePath ); $insertTags = $deviceTemplates->xpath("//template"); foreach( $insertTags as $key => $xmlTemplate ) { $this->templateList[ (String)$xmlTemplate['name'] ] = $xmlTemplate[0]->asXML(); } } if( isset( $this->templateList[ $template ] ) === false ) { if( file_exists( $widgetTemplatePath ) === true ) { $this->templateList[ $template ] = file_get_contents( $widgetTemplatePath ); } else { $this->templateList[ $template ] = false; } } return $this->templateList[ $template ]; } function PrepareMustacheParameter() { $cosConfProxy = new CosConfProxy(); $entityPassword = $this->configProxy->GetPassword( $this->entity['entid'] )['data']; $systemDefaults = $this->configProxy->Get( "admui.param" )['data']; $systemLicense = $this->configProxy->Get( "admui.license" )['data']; $cosConfData = $cosConfProxy->Read()['data']; if( isset( $entityPassword ) === false || empty( $entityPassword ) ) { return false; } if( isset( $systemDefaults ) === false || empty( $systemDefaults ) ) { return false; } if( isset( $systemLicense ) === false || empty( $systemLicense ) ) { return false; } $this->mustacheParameter = Array( 'this' => null, 'parent' => null, 'system' => null, 'current' => null ); $this->mustacheParameter['this'] = $this->entity; $this->mustacheParameter['this']['entaddr'] = str_replace( ".", "", $this->entity['entid'] ); $this->mustacheParameter['device'][ $this->mustacheParameter['this']['class'] ] = true; $this->mustacheParameter['doIgnore'] = function( $text, $render) { return $text; }; $this->mustacheParameter['this']['authorize']['sip']['pass'] = $entityPassword; $this->mustacheParameter['this']['password'] = $entityPassword; if( isset( $this->mustacheParameter['this']['video']['http'] ) === true && $this->mustacheParameter['this']['video']['http'] === true ) { $this->mustacheParameter['this']['videoUrl'] = "http://" . $_SERVER['HTTP_HOST'] . ":8080/" . $this->mustacheParameter['this']['uuid'] . "/video.mjpeg"; } $this->mustacheParameter['parent'] = $this->parent; $this->mustacheParameter['parent']['entaddr'] = str_replace( ".", "", $this->parent['entid'] ); $this->mustacheParameter['system']['srvid'] = "system.fj"; foreach( $systemDefaults['regtimes'] as $regType => $regTime ) { $this->mustacheParameter['system'][ $regType ] = $regTime; } if( isset( $systemDefaults['locale']['lang'] ) ) { $this->mustacheParameter['system']['lang'] = $systemDefaults['locale']['lang']; } if( isset( $systemDefaults['locale']['timezone'] ) ) { $this->mustacheParameter['system']['timezone'] = $cosConfData['timezone']['posix']; } else { $this->mustacheParameter['system']['timezone'] = $cosConfData['timezone']['posix']; } if( isset( $systemLicense['ssh']['sshPublicKey'] ) ) { $this->mustacheParameter['system']['sshPublicKey'] = $systemLicense['ssh']['sshPublicKey']; } $this->setRingtones(); } public function appendSimpleXmlNodes( $targetNode, SimpleXMLElement $toAppendNode ) { if( $toAppendNode->count() > 1 && $toAppendNode->getName() !== "stpt" && $toAppendNode->getName() !== "action" ) { foreach( $toAppendNode as $key => $xmlNode ) { $toDom = dom_import_simplexml( $targetNode ); $fromDom = dom_import_simplexml( $xmlNode ); $toDom->appendChild( $toDom->ownerDocument->importNode( $fromDom, true ) ); } } else { $toDom = dom_import_simplexml( $targetNode ); $fromDom = dom_import_simplexml( $toAppendNode ); $toDom->appendChild( $toDom->ownerDocument->importNode( $fromDom, true ) ); } } function setRingtones() { $this->mustacheParameter['announcementtone'] = "Glockenspiel"; $this->mustacheParameter['calltone'] = "Glockenspiel"; $this->mustacheParameter['doorcalltone'] = "Suitcase_1"; $this->mustacheParameter['storeycalltone'] = "Suitcase_1"; foreach( $this->mustacheParameter['this']['deviceConfig'] as $deviceConfigEntry ) { if( isset( $deviceConfigEntry['template'] ) && $deviceConfigEntry['template'] == "ringtone" ) { $this->mustacheParameter['calltone'] = $this->getRingtone( $deviceConfigEntry, "calltone" ); $this->mustacheParameter['doorcalltone'] = $this->getRingtone( $deviceConfigEntry, "doorcalltone" ); $this->mustacheParameter['storeycalltone'] = $this->getRingtone( $deviceConfigEntry, "storeycalltone" ); $this->mustacheParameter['announcementtone'] = $this->getRingtone( $deviceConfigEntry, "announcementtone" ); break; } } } function getRingtone( $deviceConfigEntry, $ringtone ) { return isset( $deviceConfigEntry[ $ringtone ] ) ? $deviceConfigEntry[ $ringtone ] : $this->mustacheParameter[ $ringtone ]; } }