<?php
 use PHPUnit\Framework\TestCase; $accessConfig = parse_ini_file( __DIR__ . "/../../../agw.ini" ); define( "LOG_PATH", $accessConfig['log'] ); include_once dirname( __FILE__ ) . "/../../proxy/ConfigProxy.php"; include_once dirname( __FILE__ ) . "/../../proxy/AdminProxy.php "; include_once dirname( __FILE__ ) . "/../../proxy/SessionProxy.php"; include_once dirname( __FILE__ ) . "/../../lib/SESSION.php"; include_once dirname( __FILE__ ) . "/../../lib/Envelope.php"; include_once dirname( __FILE__ ) . "/../../lib/XHREnvelope.php"; include_once dirname( __FILE__ ) . "/../../lib/helpers.php"; include_once dirname( __FILE__ ) . "/../../lib/NamedPipe.php"; include_once dirname( __FILE__ ) . "/../../lib/LOG.php"; define( "TEST_ENTITIES", dirname( __FILE__ ) . "/../Testdata/TestEntities/" ); class ConfigProxyTest extends TestCase { private $configProxy; private const APARTMENT_CALL_NUMBER = "999"; private const APARTMENT_UID = 999; private const APARTMENT_MAC = "00:01:AA:FF:00:01"; private const APARTMENT_PASSWORD = "0000"; private $toDeleteBranchEntityId; public function test__construct() { $this->configProxy = new ConfigProxy(); $this->assertNotEmpty( $this->configProxy ); } public function testAdd() { $this->PrepareSession(); $testEntity = file_get_contents( TEST_ENTITIES . "apartment.15.json" ); $testEntity = str_replace( "apartment.15", "apartment.999", $testEntity ); $testEntity = json_decode( $testEntity, true ); $testEntity['name'] = "Apartment 999 ProxyTest"; $testEntity['adminUi']['macaddr'] = self::APARTMENT_MAC; $testEntity['authorize']['sip']['account'] = self::APARTMENT_CALL_NUMBER; $testEntity['phoner']['callnumber'] = self::APARTMENT_CALL_NUMBER; $response = $this->configProxy->Add( $testEntity ); $this->assertIsArray( $response ); $this->assertTrue( $response['data'] ); } public function testGetEntityIdFromMacAddress() { $this->PrepareSession(); $entityId = $this->configProxy->GetEntityIdFromMacAddress( self::APARTMENT_MAC )['data']; $this->assertEquals( "apartment.999", $entityId ); } public function testGetRoot() { $this->PrepareSession(); $root = $this->configProxy->GetRoot(); $this->assertNotEmpty( $root ); $this->assertIsArray( $root ); $this->assertEquals( "system.fj", $root['data'] ); } public function testSetPassword() { $this->PrepareSession(); $envelopeData = array( "passwordKey" => "password", "password" => self::APARTMENT_PASSWORD, "entityId" => "apartment.999" ); $response = $this->configProxy->SetPassword( $envelopeData ); $this->assertNotEmpty( $response ); $this->assertIsArray( $response ); $this->assertTrue( $response['data'] ); } public function testGetPassword() { $this->PrepareSession(); $response = $this->configProxy->GetPassword( "apartment.999" ); $this->assertNotEmpty( $response ); $this->assertIsArray( $response ); $this->assertEquals( self::APARTMENT_PASSWORD, $response['data'] ); } public function testCreateUid() { $this->PrepareSession(); $response = $this->configProxy->CreateUid( "apartment" ); $this->assertNotEmpty( $response ); $this->assertIsArray( $response ); $this->assertIsNumeric( $response['data'] ); } public function testUpdate() { $this->PrepareSession(); define( "COMMENT_TEST_STRING", "Test Config Proxy Apartment.999" ); $entity = $this->configProxy->Get( "apartment.999" )['data']; $this->assertNotEmpty( $entity ); $this->assertIsArray( $entity ); $saveOldComment = $entity['comment']; $entity['comment'] = COMMENT_TEST_STRING; $this->configProxy->Update( $entity ); $entity = $this->configProxy->Get( "apartment.999" )['data']; $this->assertEquals( COMMENT_TEST_STRING, $entity['comment'] ); $entity['comment'] = $saveOldComment; $this->configProxy->Update( $entity ); $entity = $this->configProxy->Get( "apartment.999" )['data']; $this->assertEquals( $saveOldComment, $entity['comment'] ); } public function testGetEntityIdFromCallNumber() { $this->PrepareSession(); $data = array( "callnumber" => self::APARTMENT_CALL_NUMBER ); $entityId = $this->configProxy->GetEntityIdFromCallNumber( "999" )['data']; $this->assertNotEmpty( $entityId ); $this->assertIsString( $entityId ); $this->assertEquals( "apartment.999", $entityId ); } public function testGet() { $this->PrepareSession(); $entity = $this->configProxy->Get( "apartment.999" )['data']; $this->assertNotEmpty( $entity ); $this->assertIsArray( $entity ); } public function testGetTree() { $this->PrepareSession(); $entity = $this->configProxy->GetTree()['data']; $this->assertNotEmpty( $entity ); $this->assertIsArray( $entity ); } public function testBranchMove() { $this->PrepareSession(); $this->adminProxy = new AdminProxy(); $folderCreateParameter = Array( "class" => "folder", "parent" => "folder.confdev", "lang" => "de", "deviceTemplate" => null, "macaddr" => null, "password" => null, ); $this->adminProxy->Create( $folderCreateParameter, "de" ); $apartmentCreateParameter = Array( "class" => "apartment", "parent" => "folder.confdev", "lang" => "de", "deviceTemplate" => "AHTV_870-0", "macaddr" => null, "password" => null, ); $responseCreatedFolder = $this->adminProxy->Create( $folderCreateParameter, "de" )['data']; $responseCreatedApartment = $this->adminProxy->Create( $apartmentCreateParameter, "de" )['data']; $entity = $this->configProxy->BranchMove( $responseCreatedApartment['entid'], $responseCreatedFolder['entid'] ); $this->toDeleteBranchEntityId = $responseCreatedFolder['entid']; $this->assertTrue( $entity ); $deleteEntityIds = $this->configProxy->BranchDelete( $this->toDeleteBranchEntityId ); foreach( array_reverse( $deleteEntityIds ) as $key => $delteEntityId ) { $responseDeleteEntity = $this->configProxy->Delete( $delteEntityId ); $this->assertTrue( $responseDeleteEntity['data'] ); } $tree = $this->configProxy->GetTree()['data']; $tree = json_encode( $tree ); $this->assertStringNotContainsString( $this->toDeleteBranchEntityId, $tree ); } public function testDelete() { $this->PrepareSession(); $response = $this->configProxy->Delete( "apartment.999" ); $this->assertIsArray( $response ); $this->assertTrue( $response['data'] ); } private function PrepareSession() { $this->devGuid = "dev4B274CF7-3913-0DD1-E81C-7854DC3AEE56"; $this->configProxy = new ConfigProxy(); $this->sessionProxy = new SessionProxy( $this->devGuid ); SESSION::SetSessionId( $this->devGuid ); $this->sessionProxy->Get( $this->devGuid ); $this->configProxy = new ConfigProxy(); } } 