<?php
 abstract class ListBase { protected $entid; protected $entryName; protected $envelopeCmd; protected $envelopeData; protected $envelopeResponse; protected $jsonList; protected $lang; protected $mac; protected $macFile; protected $np; protected $typeOfList; protected $xml; protected $preparedData; protected $jsonMode; protected $statepointProxy; protected $configProxy; function __construct( $entid, $lang = null, $jsonMode = false, $mac = null ) { $this->entid = $entid; $this->jsonMode = $jsonMode; $this->lang = $lang; $this->mac = $mac; $this->macFile = strtolower( preg_replace( "/:/", "-", $this->mac ) ); $this->np = null; $this->m_proxy = null; $this->statepointProxy = new StatepointProxy(); $this->configProxy = new ConfigProxy(); if( !$lang ) { $lang = "en"; } } abstract function setProxy(); abstract function setData($filter = null); abstract function createRequestedList(); function sendEnvelope( $filter = null ) { $this->setData( $filter ); $this->setProxy(); StopWatch::start(); $listResp = $this->m_proxy->_List( $this->entid, $this->envelopeData['filter'], $this->lang ); $time = StopWatch::elapsed(); LOG::debug( __CLASS__, "LIST.READ Envelope took %0.2f ms", $time*1000 ); $this->envelopeResponse = $listResp; $this->jsonList = sizeof( $this->envelopeResponse) > 0 ? $this->envelopeResponse['data'] : false; $this->createRequestedList(); return $this->writeResult(); } function formatXml( $simpleXmlNode ) { $dom = dom_import_simplexml( $simpleXmlNode )->ownerDocument; $dom->formatOutput = true; $dom->preserveWhiteSpace = false; return $dom->saveXML(); } function getEntityFromAddr( $addr ) { preg_match( "/([\\\\]|[\/]){1}\w+\.\d+([\\\\]|[\/]){1}/", $addr, $entity ); $entity = preg_replace( "/[\\\\]|[\/]/", "", $entity[0] ); return $this->configProxy->Get( $entity )['data']; } function getTypeConfig( $entity ) { $result = Array(); switch ( $entity['class'] ) { case 'software': $result['type'] = "concierge"; $result['announce'] = "false"; $result['autoAnswer'] = "false"; break; case 'door': $result['type'] = "door"; $result['announce'] = "false"; $result['autoAnswer'] = "true"; break; case 'callq': $result['type'] = "group"; $result['announce'] = "false"; $result['autoAnswer'] = "false"; break; case 'group': $result['type'] = "group"; $result['announce'] = "false"; $result['autoAnswer'] = "false"; break; default: $result['type'] = "intern"; $result['announce'] = "false"; $result['autoAnswer'] = "false"; break; } return $result; } function writeJson( $listtype ) { file_put_contents( DEVCONF_PATH . $listtype . "_" . $this->macFile . ".json" , json_encode( $this->jsonList, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES|JSON_UNESCAPED_UNICODE ) ); } function writeXml( ) { $xml = new SimpleXMLElement('<siedle/>'); $listNode = $xml->addChild( $this->typeOfList ); echo $xml->asXML(); $this->arrayToXml( $this->jsonList, $listNode); echo $xml->asXML(); } function arrayToXml( $arr, $listNode, $saveParent = "", $wasAssoziative = false ) { foreach ($arr as $key => $value) { if( is_array( $value ) ) { if( !isset( $saveParent ) || $saveParent == "" ) { $this->arrayToXml( $value, $listNode, $key ); } else if( is_string( $key ) ) { $this->arrayToXml( $value, $listNode->addChild( $saveParent ), $key, true ); } else { if( $wasAssoziative ) { $this->arrayToXml( $value, $listNode, $saveParent, true ); } else { $this->arrayToXml( $value, $listNode->addChild( $saveParent ), $saveParent ); } } } else { if( $wasAssoziative ) { $listNode = $listNode->addChild( $saveParent ); $wasAssoziative = false; } $listNode->addChild( $key, htmlspecialchars($value) ); } } } function writeResult() { if( $this->jsonMode ) { $jsonString = json_encode( $this->preparedData, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES|JSON_UNESCAPED_UNICODE ); return $jsonString; } else { $this->xml = new SimpleXMLElement( "<siedle/>" ); $listNode = $this->xml->addChild( htmlspecialchars($this->typeOfList) ); $this->arrayToXml($this->preparedData, $listNode); $xmlString = $this->formatXml( $this->xml ); return $xmlString; } } } ?>